#!/usr/bin/env python

### THIS LINE IN THE TOP
from dttcmd import *

###GLOBAL VAR
main_round = 72     # USE FOR ROUND FRONT STEM
                    # 68=CLOSE TO FRONT=WIDE FONT, 72=NORMAL
thai_round = main_round - 2
shift_edge = 16
ppem_allow_shoot = 32
ppem_allow_round = 42
shift_slant = 6

### GENERATED CODE
func_arg_list = [
[2, 0], [1, 0], [3, 1], [1, 1], [4, 0], 
[0, 1], [0, 1], [0, 1], [3, 0], [3, 0], 
[2, 0], [1, 0], [1, 0], [4, 0], [3, 0], 
[5, 0], [2, 0], [2, 0], [2, 0], [3, 0], 
[0, 0], [1, 1], [2, 0], [6, 0], [4, 0], 
[2, 0], [10,0], [4,0],]

cvt_dict = {
    'vbase_shoot_max'   : 0,   #-27
    'vbase-shoot'       : 1,   #-16
    'evheight' 			: 2,   #1117
        'tvheight' 			: 2,   #1117
    'evheight_shoot' 	: 3,   #1144
    'evheight_num'      : 4,   #1489
        'ecvheight'         : 4,   #1489
    'evheight_b'        : 5,   #1556
    'tvheight_po'       : 6,   #1649
    'tvheight_lu'       : 7,   #-442
        'evheight_p'         : 7,   #-442
    'tvheight_num'      : 8,   #924
    'cvt_9' : 9,   #0
    'cvt_10' : 10,   #0
    'cvt_11' : 11,   #0
    'cvt_12' : 12,   #0
    'estemt'            : 13,   #268
    'estemw'            : 14,   #350
    'estemw_num'        : 15,   #363
    'ecstemw'           : 16,   #374
        'estemwc_num'           : 16,   #374
    'ecstemwc'          : 17,   #386
    'ecstemt'           : 18,   #284
        'estemt_num'        : 18,   #284
    'ecstemtc'          : 19,   #274
        'estemtc_num'      : 19,   #274
    'estemwc'           : 20,   #359
    'estemtc'           : 21,   #252
    'estemtc_max'       : 22,   #272
    'tstemw'            : 23,   #291
        'tstemw_num'            : 23,   #291
    'tstemwc'           : 24,   #281
        'tstemwc_num'           : 24,   #281
    'tstemt'            : 25,   #240
        'tstemt_num'            : 25,   #240
    'tstemtc'           : 26,   #242
        'tstemtc_num'           : 26,   #242
    'headdia'           : 27,   #434
    'headstem'          : 28,   #131
    'headhole'          : 29,   #172
    'hsph'              : 30,   #318    #headstemplushole
    'tstemt_mid'        : 31,   #211
        'tstemt_thin'        : 31,   #211
        'tstemtc_thin'        : 31,   #211
    'estemt_mid'        : 32,   #211
    'estemt_t'          : 33,   #244
    'ecstemt_mid'       : 34,   #260
    'estemw_thin'       : 35,   #330
    'estemw_sign'       : 36,   #226    #sign stem width
    'tstemwc_thin'      : 37,   #264
    }

#---GENERATE STEM FUNCTION---
#predefine delta string of stem (put before gen_cvt_func)
#example:
#   ds_headstem = "9-4 30-4 31-4 32-4 33-4 34-4 "
#   ds_headstemplushole = "9-4 30+4 31+4 32-4 33-4 34-4 "
#   ds_headsara = "9-4 "
 
#COMMON ds
#ds_headstem = "14-1 15-1 16-2 17-2 18-1 19-2 20-2 21-3 22-3 23-4 24-3 25-3 26-2 27-2 28-2 29-2 30-2 "
ds_headstem = "11+2 12+2 13+1 14-1 15-1 16-2 17-3 18-2 19-2 20-3 21-3 22-4 23-4 24-3 25-3 26-2 27-2 28-2 29-2 30-2 "
#
ds_hsph = "11-8 12-8 13-8 17-8 "
#ds_headhole = "9-4 10-5 11-6 12-7 13-8 18+4 19+3 20+2 21+1 24+4 25+3 26+2 27+1 "
ds_out_head2stem = "22-8 23-8 25+8 30-8 33+8 "
#ds_in_head2stem = "12-8 13-8 20-8 21-8 28-8 29-8 35-8 36-8 43-8 44-8 45-8 "
ds_in_head2stem = "9-4 17-8 22-8 23-8 "

#SPECIAL ds
#ds_estemtc = ds_tstemtc = ds_estemt_mid = ds_estemt_thin = ds_tstemt_thin = "13-1 14-1 15-1 "
ds_dryhead = '14-1 15-1 16-1 17-1 '
#ds_drycurve = "12+1 13+2 14+2 15+1 17+1 "
ds_drycurve = "12+1 13+2 14+1 17+1 "


#AUTO THIN DELTA STRING, USE IN AUTO GENERATE stemt FUNCTION
ds_autothin = "14-1 15-1 16-1 "
#
gen_cvt_func_dict = {
    #MIRP[min,black]
    #'mirp-mb':   ['ecstem*','estem*','tstem*','stem*','headdia'],
    'call 22':   ['ecstem*','estem*','tstem*','stem*','headdia'],
    #MIRP[min,rnd,grey]
    #'mirp-mrg':  ['headdia','headstem*','head_sara_stem','head_sara'],
    #MIRP[white]
    'mirp-w':  ['headhole'],
    #MIRP[grey]
    'mirp-rg':  ['hsph'],
    #MIRP[black]
    'mirp-b' : ['headstem*'],
    #MIAP[rnd]
    'miap-r' : ['evheight*','tvheight*','ecvheight*'],
    }

#create function from cvt value
#ex: estemw
#   -> estemw_1  = mirpmb('estemw',ds_estemw,direction='+')
#   -> estemw0_1 = mirp0mb('estemw',ds_estemw,direction='+')
#   -> estemw_2  = mirpmb('estemw',ds_estemw,direction='-')
#   -> estemw0_2 = mirp0mb('estemw',ds_estemw,direction='-')
for arg,cvt_list in gen_cvt_func_dict.iteritems():
    new_list = []
    for i in cvt_list:
        if i[-1]=='*': 
            c = i.strip('*')
            n = len(c)
            l = [x for x in cvt_dict.keys() if x[:n]==c]
            new_list.extend(l)
        else:
            new_list.append(i)

    for i in new_list:
        for j in ['_1','0_1','_2','0_2']:
           #1=forward/bottomup, #2=reverse/topdown
            add1 = ''
            if arg[:4] == 'call':
                cmd_line = '"%s %s ' % (arg.upper(),i,) + '%s" ' + '% (s,)'
                if j[0] == '0':
                    add1 = 'srp0(s)'
            else:
                c,a = arg.split('-')
                if c in ['miap','mdap']:
                    if j[0] == '0':
                        cmd = c + a
                    else:
                        #MIAP and MDAP the point must be rp0 only
                        continue
                else:
                    if j[0] == '0':    #m=move rp0
                        cmd = c + '0' + a
                    else:
                        cmd = c + a
                cmd_line = '%s("%s",s)' % (cmd,i,)  #mirp('cvt',s)

            if j[-1] == '1': #1=forward/bottomup, #2=reverse/topdown
                direction = '+'
            else:
                direction = '-'

            #AUTO GENERATE delta string
            try:    #if ds_CVT is defined
                exec "ds = ds_%s " % (i,)
            except: #else
                exec "ds_%s = ''" % (i,)

            #GEN FUNCTION
            exec '''def %s%s(s,direction="%s"):
    return pl(""
        , %s
        , f_dstr(s,ds_%s,direction)
        , %s
        )
''' % (i,j,direction,cmd_line,i,add1,)

            #GEN EXTRA FUNC FOR THIN OF estemt, tstemt
            #USE IN UPPER STEM OF kho_khai, kho_kwai
            #***PREDEFINE: ds_estemt_autothin
            #if arg[:4] == 'mirp' and i in ['ecstemt','ecstemtc','estemt','estemtc','tstemt','tstemtc']:
            if i in ['ecstemt','ecstemtc','estemt','estemtc','tstemt','tstemtc']:
                #AUTO GENERATE delta string
                try:
                    exec "ds_%s_autothin = sum_dstr(ds_%s + ds_autothin" % (i,i,)
                except:
                    exec "ds_%s_autothin = ds_autothin" % (i,)
                #GEN FUNC
                exec '''def %s_autothin%s(s,direction="%s"):
    return pl(""
        , %s
        , f_dstr(s,ds_%s_autothin,direction)
        )
''' % (i,j,direction,cmd_line,i,)


pseudo_prep = pl(""
, '''
SCANCTRL        511        ;SCAN conversion ConTRoL
SCANTYPE        1          ;  SCANTYPE
f_push 512
MPPEM                      ;Measure Pixels Per EM
EQ                         ;     EQual
IF              &_EQ_1     ;   IF test
INSTCTRL        1 1        ;INSTRuction execution ConTRoL
EIF                        ;    End IF
f_push 8
MPPEM                      ;Measure Pixels Per EM
GTEQ                       ;Greater Than or EQual
IF              &_GTEQ_1   ;   IF test
INSTCTRL        1 1        ;INSTRuction execution ConTRoL
EIF                        ;    End IF
#
'''
#DELTAC STEM WIDTH
, sx()
, fc_dstr('estemw',     "15-8 16-8 20+8 26+8 32+8 ")
, fc_dstr('estemwc',    "15-8 16-8 ")
, fc_dstr('estemw_num', "15-8 16-8 ")
, fc_dstr('estemw_thin',"10-8 11-8 16-8 ")
, fc_dstr('ecstemw',    "14-8 15-8 16-8 25-8 ")
, fc_dstr('ecstemwc',   "14-8 15-8 16-8 19-8 24-8 25-8 30-8 ")
, fc_dstr('tstemw',     "9+8 10+8 17+8 ")
, fc_dstr('tstemwc',    "9+8 10+8 17+8 25+8 ")
, fc_dstr('tstemwc_thin',"17+8 18+8 19+8 26+8 27+8 ")
#DELTAC STEM THICK
, sy()
, fc_dstr('estemt',     "12-8 13-8 14-8 15-8 16-8 21-8 27-8 28-8 ")
#, fc_dstr('estemtc',    "12-8 13-8 14-8 15-8 16-8 21-8 ")
, fc_dstr('estemtc',    "12-8 13-8 14-8 15-8 16-8 28+8 ")
#, fc_dstr('estemtc_max',"12-8 13-8 14-8 15-8 16-8 19-8 20-8 21-8 ")
, fc_dstr('estemtc_max',"12-8 13-8 14-8 15-8 16-8 19-8 20-8 27-8 ")
, fc_dstr('estemt_mid', "13-8 14-8 15-8 16-8 ")
, fc_dstr('ecstemt',    "11-8 12-8 13-8 14-8 15-8 16-8 18-8 19-8 26-8 ")
, fc_dstr('ecstemtc',   "12-8 13-8 14-8 15-8 16-8 19-8 ")
, fc_dstr('ecstemt_mid',"12-8 13-8 14-8 15-8 16-8 ")
, fc_dstr('estemt_t',   "13-8 14-8 15-8 16-8 21-8 ") #estemt_t
, fc_dstr('tstemt',     "12-8 13-8 14-8 15-8 16-8 22-8 30-8 31-8 ")
, fc_dstr('tstemtc',    "13-8 14-8 15-8 16-8 22-8 30-8 31-8 ")
, fc_dstr('tstemt_mid', "12-8 13-8 14-8 15-8 16-8 17-8 18-8 25-8 26-8 ")
        )

pseudo_fpgm = pl("""
                           #--- PUSHB_1   0         ;PUSH Bytes
FDEF            0          ;Function DEFinition
                           #--- PUSHB_1   0         ;PUSH Bytes
SZP0            0          ;Set Zone Pointer 0
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHB_1   42        ;PUSH Bytes
LT              42 &_MPPEM_1 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   74        ;PUSH Bytes
SROUND          74         ;Super ROUND
EIF                        ;    End IF
                           #--- PUSHB_1   0         ;PUSH Bytes
SWAP            0 &_arg_1  ;SWAP the top two elements on the stack
MIAP[rnd]       &_SWAP_1 &_SWAP_2 ;Move Indirect Absolute Point
RTG                        ;Round To Grid
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
RTDG                       ;Round To Double Grid
EIF                        ;    End IF
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHB_1   42        ;PUSH Bytes
LT              42 &_MPPEM_1 ; Less Than
IF              &_LT_1     ;   IF test
RDTG                       ;Round Down To Grid
EIF                        ;    End IF
DUP             &_arg_2    ;DUPlicate top stack element
MDRP[rp0,rnd,grey] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SZP0            1          ;Set Zone Pointer 0
MDAP[no-rnd]    &_DUP_2    ;Move Direct Absolute Point
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   1         ;PUSH Bytes
FDEF            1          ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,min,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
CALL            12 &_DUP_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   2         ;PUSH Bytes
FDEF            2          ;Function DEFinition
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM_1 &_arg_1 ;Greater Than
IF              &_GT_1     ;   IF test
RCVT            &_arg_2    ;Read Control Value Table entry
SWAP            &_RCVT_1 &_arg_3 ;SWAP the top two elements on the stack
EIF                        ;    End IF
POP             &_SWAP_1   ;POP top stack element
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=1: &_SWAP_2
#------------------

                           #--- PUSHB_1   3         ;PUSH Bytes
FDEF            3          ;Function DEFinition
ROUND[Black]    &_arg_1    ;ROUND value
RTG                        ;Round To Grid
DUP             &_ROUND_1  ;DUPlicate top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
LT              64 &_DUP_1 ; Less Than
IF              &_LT_1     ;   IF test
POP             &_DUP_2    ;POP top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=1: 64
#------------------

                           #--- PUSHB_1   4         ;PUSH Bytes
FDEF            4          ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
POP             &_arg_1    ;POP top stack element
SWAP            &_arg_2 &_arg_3 ;SWAP the top two elements on the stack
POP             &_SWAP_1   ;POP top stack element
ROFF                       ; Round OFF
IF              &_SWAP_2   ;   IF test
MDRP[rp0,min,rnd,black] &_arg_4    ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg_4    ;Move Direct Relative Point
EIF                        ;    End IF
ELSE                       ;ELSE clause
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM_1 &_arg_1 ;Greater Than
IF              &_GT_1     ;   IF test
IF              &_arg_2    ;   IF test
MIRP[rp0,min,rnd,black] &_arg_3 &_arg_4 ;Move Indirect Relative Point
ELSE                       ;ELSE clause
MIRP[min,rnd,black] &_arg_3 &_arg_4 ;Move Indirect Relative Point
EIF                        ;    End IF
ELSE                       ;ELSE clause
SWAP            &_arg_2 &_arg_3 ;SWAP the top two elements on the stack
POP             &_SWAP_1   ;POP top stack element
                           #--- PUSHB_1   5         ;PUSH Bytes
CALL            5          ;CALL function
IF              &_f5_retval_1 ;   IF test
                           #--- PUSHB_1   70        ;PUSH Bytes
SROUND          70         ;Super ROUND
EIF                        ;    End IF
IF              &_SWAP_2   ;   IF test
MDRP[rp0,min,rnd,black] &_arg_4    ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg_4    ;Move Direct Relative Point
EIF                        ;    End IF
EIF                        ;    End IF
EIF                        ;    End IF
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   5         ;PUSH Bytes
FDEF            5          ;Function DEFinition
GFV                        ;Get Freedom Vector
NOT             &_GFV_1    ;logical NOT
AND             &_NOT_1 &_GFV_2 ;logical AND
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_AND_1
#------------------

                           #--- PUSHB_1   6         ;PUSH Bytes
FDEF            6          ;Function DEFinition
                           #--- PUSHB_2   34 1      ;PUSH Bytes
GETINFO         1          ;GET INFOrmation
LT              &_GETINFO_1 34 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   32        ;PUSH Bytes
GETINFO         32         ;GET INFOrmation
NOT             &_GETINFO_1 ;logical NOT
NOT             &_NOT_1    ;logical NOT
ELSE                       ;ELSE clause
                           #--- PUSHB_1   0         ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT_1
#------------------

                           #--- PUSHB_1   7         ;PUSH Bytes
FDEF            7          ;Function DEFinition
                           #--- PUSHB_2   36 1      ;PUSH Bytes
GETINFO         1          ;GET INFOrmation
LT              &_GETINFO_1 36 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
GETINFO         64         ;GET INFOrmation
NOT             &_GETINFO_1 ;logical NOT
NOT             &_NOT_1    ;logical NOT
ELSE                       ;ELSE clause
                           #--- PUSHB_1   0         ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT_1
#------------------

                           #--- PUSHB_1   8         ;PUSH Bytes
FDEF            8          ;Function DEFinition
SRP2            &_arg_1    ;Set Reference Point 2
SRP1            &_arg_2    ;Set Reference Point 1
DUP             &_arg_3    ;DUPlicate top stack element
IP              &_DUP_1    ;Interpolate Point
MDAP[rnd]       &_DUP_2    ;Move Direct Absolute Point
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   9         ;PUSH Bytes
FDEF            9          ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
RDTG                       ;Round Down To Grid
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
MDRP[rnd,grey]  &_DUP_1    ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_DUP_2    ;Move Direct Relative Point
EIF                        ;    End IF
DUP             &_DUP_2    ;DUPlicate top stack element
                           #--- PUSHB_1   3         ;PUSH Bytes
CINDEX          3          ;Copy the INDEXed element to the top of the stack
MD[grid]        &_CINDEX_1 &_DUP_1 ;Measure Distance
SWAP            &_MD_1 &_DUP_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
                           #--- PUSHB_1   4         ;PUSH Bytes
MINDEX          4          ;Move the INDEXed element to the top of the stack
MD[orig]        &_DUP_1 &_DUP_2 ;Measure Distance
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_MD_1   ; Less Than
IF              &_LT_1     ;   IF test
ROLL            &_SWAP_2 &_arg_2 &_arg_3 ;ROLL the top three stack elements
NEG             &_ROLL_1   ;    NEGate
ROLL            &_NEG_1 &_ROLL_2 &_ROLL_3 ;ROLL the top three stack elements
SUB             &_ROLL_1 &_ROLL_2 ;  SUBtract
DUP             &_SUB_1    ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_DUP_1  ; Less Than
IF              &_LT_1     ;   IF test
SHPIX           &_DUP_2 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
ROLL            &_arg_2 &_arg_3 &_arg_4 ;ROLL the top three stack elements
ROLL            &_ROLL_1 &_ROLL_2 &_ROLL_3 ;ROLL the top three stack elements
SUB             &_ROLL_1 &_ROLL_2 ;  SUBtract
DUP             &_SUB_1    ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
GT              0 &_DUP_1  ;Greater Than
IF              &_GT_1     ;   IF test
SHPIX           &_DUP_2 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_5    ;POP top stack element
POP             &_arg_6    ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   10        ;PUSH Bytes
FDEF            10         ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
POP             &_arg_1    ;POP top stack element
SRP0            &_arg_2    ;Set Reference Point 0
ELSE                       ;ELSE clause
SRP0            &_arg_1    ;Set Reference Point 0
POP             &_arg_2    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   11        ;PUSH Bytes
FDEF            11         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
CALL            12 &_DUP_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   12        ;PUSH Bytes
FDEF            12         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval_1 ;logical NOT
IF              &_NOT_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
DUP             &_DUP_1    ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_SWAP_2 ;  SUBtract
ROUND[White]    &_SUB_1    ;ROUND value
DUP             &_ROUND_1  ;DUPlicate top stack element
IF              &_DUP_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
ABS             &_DUP_1    ;ABSolute value
DIV             &_ABS_1 &_DUP_2 ;    DIVide
SHPIX           &_DIV_1 &_DUP_2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_2    ;POP top stack element
POP             &_arg_3    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg_2    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   13        ;PUSH Bytes
FDEF            13         ;Function DEFinition
SRP2            &_arg_1    ;Set Reference Point 2
SRP1            &_arg_2    ;Set Reference Point 1
DUP             &_arg_3    ;DUPlicate top stack element
DUP             &_DUP_1    ;DUPlicate top stack element
IP              &_DUP_1    ;Interpolate Point
MDAP[rnd]       &_DUP_2    ;Move Direct Absolute Point
DUP             &_DUP_2    ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_arg_4 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
ROLL            &_GC_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
GC[cur]         &_ROLL_1   ;Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_ROLL_2 ;  SUBtract
SWAP            &_SUB_1 &_ROLL_3 ;SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_ROLL_3 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
MD[orig]        &_SWAP_1 &_SWAP_2 ;Measure Distance
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_MD_1   ; Less Than
IF              &_LT_1     ;   IF test
SWAP            &_ROLL_3 &_ROLL_3 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
GT              0 &_SWAP_1 ;Greater Than
IF              &_GT_1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
SHPIX           64 &_SWAP_2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
SWAP            &_arg_5 &_arg_6 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_SWAP_1 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
NEG             64         ;    NEGate
SHPIX           &_NEG_1 &_SWAP_2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_7    ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   14        ;PUSH Bytes
FDEF            14         ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
RTDG                       ;Round To Double Grid
MDRP[rp0,rnd,white] &_arg_1    ;Move Direct Relative Point
RTG                        ;Round To Grid
POP             &_arg_2    ;POP top stack element
POP             &_arg_3    ;POP top stack element
ELSE                       ;ELSE clause
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
ROLL            &_DUP_2 &_arg_2 &_arg_3 ;ROLL the top three stack elements
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM_1 &_ROLL_1 ;Greater Than
IF              &_GT_1     ;   IF test
DUP             &_ROLL_2   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_3 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
MD[grid]        &_SWAP_1 &_SWAP_2 ;Measure Distance
DUP             &_MD_1     ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
NEQ             0 &_DUP_1  ; Not EQual
IF              &_NEQ_1    ;   IF test
SHPIX           &_DUP_2 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   15        ;PUSH Bytes
FDEF            15         ;Function DEFinition
SWAP            &_arg_1 &_arg_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
DUP             &_DUP_2    ;DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval_1 ;logical NOT
IF              &_NOT_1    ;   IF test
SWAP            &_DUP_2 &_SWAP_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
IF              &_DUP_1    ;   IF test
MPPEM                      ;Measure Pixels Per EM
GTEQ            &_MPPEM_1 &_DUP_2 ;Greater Than or EQual
ELSE                       ;ELSE clause
POP             &_GTEQ_1   ;POP top stack element
                           #--- PUSHB_1   1         ;PUSH Bytes
EIF                        ;    End IF
IF              &_GTEQ_1   ;   IF test
ROLL            &_SWAP_2 &_arg_3 &_arg_4 ;ROLL the top three stack elements
                           #--- PUSHB_1   4         ;PUSH Bytes
MINDEX          4          ;Move the INDEXed element to the top of the stack
MD[grid]        &_ROLL_1 &_ROLL_2 ;Measure Distance
SWAP            &_MD_1 &_ROLL_3 ;SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_arg_5 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_SWAP_2 ;ROLL the top three stack elements
MD[grid]        &_ROLL_1 &_ROLL_2 ;Measure Distance
ROLL            &_MD_1 &_ROLL_3 &_ROLL_3 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
SUB             &_SWAP_1 &_SWAP_2 ;  SUBtract
SHPIX           &_SUB_1 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_3    ;POP top stack element
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
POP             &_arg_6    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             1          ;POP top stack element
POP             &_SWAP_2   ;POP top stack element
POP             &_arg_3    ;POP top stack element
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=5:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   16        ;PUSH Bytes
FDEF            16         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,min,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
CALL            18 &_DUP_2 &_arg_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   17        ;PUSH Bytes
FDEF            17         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
CALL            18 &_DUP_2 &_arg_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   18        ;PUSH Bytes
FDEF            18         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval_1 ;logical NOT
IF              &_NOT_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
DUP             &_DUP_1    ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_SWAP_2 ;  SUBtract
ROUND[White]    &_SUB_1    ;ROUND value
ROLL            &_ROUND_1 &_DUP_2 &_arg_2 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_SWAP_2 ;SWAP the top two elements on the stack
SUB             &_SWAP_1 &_SWAP_2 ;  SUBtract
ROUND[White]    &_SUB_1    ;ROUND value
ADD             &_ROUND_1 &_ROLL_2 ;       ADD
DUP             &_ADD_1    ;DUPlicate top stack element
IF              &_DUP_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
ABS             &_DUP_1    ;ABSolute value
DIV             &_ABS_1 &_DUP_2 ;    DIVide
SHPIX           &_DIV_1 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_3    ;POP top stack element
POP             &_arg_4    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg_2    ;POP top stack element
POP             &_arg_3    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   19        ;PUSH Bytes
FDEF            19         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_arg_2 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
SDPVTL[orthog]  &_ROLL_1 &_ROLL_2 ;Set Dual Projection Vector To Line
DUP             &_ROLL_3   ;DUPlicate top stack element
                           #--- PUSHB_1   3         ;PUSH Bytes
CINDEX          3          ;Copy the INDEXed element to the top of the stack
MD[orig]        &_CINDEX_1 &_DUP_1 ;Measure Distance
ABS             &_MD_1     ;ABSolute value
SWAP            &_ABS_1 &_DUP_2 ;SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_ROLL_3 ;ROLL the top three stack elements
SPVTL[orthog]   &_ROLL_1 &_ROLL_2 ;Set Projection Vector To Line
                           #--- PUSHB_1   32        ;PUSH Bytes
LT              32 &_ROLL_3 ; Less Than
IF              &_LT_1     ;   IF test
ALIGNRP         &_arg_3    ;ALIGN to Reference Point
ELSE                       ;ELSE clause
MDRP[grey]      &_arg_3    ;Move Direct Relative Point
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   20        ;PUSH Bytes
FDEF            20         ;Function DEFinition
                           #--- PUSHB_4   0 64 1 64 ;PUSH Bytes
WS              64 1       ;Write Store
WS              64 0       ;Write Store
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHW_1   4096      ;PUSH Words
MUL             4096 &_MPPEM_1 ;  MULtiply
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHW_1   4096      ;PUSH Words
MUL             4096 &_MPPEM_1 ;  MULtiply
DUP             &_MUL_1    ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_MUL_1 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
NEQ             &_ROLL_1 &_ROLL_2 ; Not EQual
IF              &_NEQ_1    ;   IF test
DUP             &_ROLL_3   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_3 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
GT              &_ROLL_1 &_ROLL_2 ;Greater Than
IF              &_GT_1     ;   IF test
SWAP            &_ROLL_3 &_ROLL_3 ;SWAP the top two elements on the stack
DIV             &_SWAP_1 &_SWAP_2 ;    DIVide
DUP             &_DIV_1    ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
SWAP            0 &_DUP_1  ;SWAP the top two elements on the stack
WS              &_SWAP_1 &_SWAP_2 ;Write Store
ELSE                       ;ELSE clause
DIV             &_DUP_2 &_arg_1 ;    DIVide
DUP             &_DIV_1    ;DUPlicate top stack element
                           #--- PUSHB_1   1         ;PUSH Bytes
SWAP            1 &_DUP_1  ;SWAP the top two elements on the stack
WS              &_SWAP_1 &_SWAP_2 ;Write Store
EIF                        ;    End IF
DUP             &_DUP_2    ;DUPlicate top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
GT              64 &_DUP_1 ;Greater Than
IF              &_GT_1     ;   IF test
                           #--- PUSHB_3   0 32 0    ;PUSH Bytes
RS              0          ;Read Store
MUL             &_RS_1 32  ;  MULtiply
WS              &_MUL_1 0  ;Write Store
                           #--- PUSHB_3   1 32 1    ;PUSH Bytes
RS              1          ;Read Store
MUL             &_RS_1 32  ;  MULtiply
WS              &_MUL_1 1  ;Write Store
                           #--- PUSHB_1   32        ;PUSH Bytes
MUL             32 &_DUP_2 ;  MULtiply
                           #--- PUSHB_1   25        ;PUSH Bytes
NEG             25         ;    NEGate
JMPR            &_NEG_1    ;JuMP Relative
POP             &_MUL_1    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg_1    ;POP top stack element
POP             &_arg_2    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=0: 
#------------------
FDEF 21
#SET PROPER SROUND VALUE FOR CURRENT PPEM
#USED IN HINTING FROM s4 TO s1
#ARG: r=PRESET ROUND VALUE
#START                      ;r
f_push  144                 ;144 r
SWAP                        ;r 144
SUB     &_r &_144           ;sub (144-r)
ADD     1 &_sub             ;add1   #DEFAULT=144-r+1
MPPEM                       ;mppem add1
EQ  9 &_mppem              ;eq add1
IF  &_eq                    ;add1
    ADD 2 &_add1            ;sub1   #15ppem=144-r
EIF
MPPEM                       ;mppem add1
EQ  10 &_mppem              ;eq add1
IF  &_eq                    ;add1
    ADD 1 &_add1            ;sub1   #15ppem=144-r
EIF
MPPEM                       ;mppem add1
EQ  11 &_mppem              ;eq add1
IF  &_eq                    ;add1
    SUB 3 &_add1            ;sub1   #15ppem=144-r
EIF
MPPEM                       ;mppem add1
EQ  14 &_mppem              ;eq add1
MPPEM                       ;mppem add1
EQ  15 &_mppem              ;eq add1
OR
IF  &_eq                    ;add1
    SUB 2 &_add1            ;sub1   #15ppem=144-r
EIF
MPPEM                       ;mppem add1
EQ  17 &_mppem              ;eq add1
MPPEM                       ;mppem add1
EQ  19 &_mppem              ;eq add1
OR
IF  &_eq                    ;add1
    ADD 2 &_add1            ;sub1   #15ppem=144-r
EIF
MPPEM
EQ  20 &_mppem
MPPEM
EQ  22 &_mppem 
OR
IF  &_and
    ADD 2 &_ADD1
EIF
MPPEM
EQ  24 &_mppem 
IF  &_and
    SUB 1 &_ADD1
EIF
ENDF
#arg=1,ret=1
#------------------
#stem width round below 42
FDEF 22
MPPEM
""" + """\
LT      %s &_mppem #F#
""" % (ppem_allow_round,) + """\
IF
    MIRP[min,rnd,black] &_arg_1 &_arg_2
ELSE
    MIRP[min,black] &_arg_1 &_arg_2
EIF
ENDF
#arg=2,ret=0
#------------------
FDEF 23
#ALIGN 4 POINTS s0,s1,s4,sx IN PROPER POSITION
#1.ALIGN sx,s4
#2.FIND DIFF DISTANCE OF s0,sx BETWEEN grid/orig
#3.MOVE TO s1 PLUS DIFF DISTANCE
#arg: s0 s1 s4 sx r min
#   r=round value (main_round)
#   min=min distance. from sx to s4, 1=min, 0=no min
#START                              ;s0 s1 s4 sx r m
CINDEX  4 #F#                       ;sx s0 s1 s4 sx r m
MDAP[rnd]   &_sx                    ;s0 s1 s4 sx r m
CINDEX  3 #F#                       ;s4 s0 s1 s4 sx r m
MINDEX  7 #F#                       ;m s4 s0 s1 s4 sx r
EQ      0 &_m                       ;eq s4 s0 s1 s4 sx r
IF      &_eq                        ;s4 s0 s1 s4 sx r
    MDRP[rp0,rnd,white] &_s4        ;s0 s1 s4 sx r
ELSE
    MDRP[rp0,min,rnd,white] &_s4    ;s0 s1 s4 sx r
EIF
CINDEX  2 #F#                       ;s1 s0 s1 s4 sx r
MDRP[rp0,grey]  &_s1                ;s0 s1 s4 sx r
#
CINDEX  4 #F#                       ;sx s0 s1 s4 sx r
CINDEX  2 #F#                       ;s0 sx s0 s1 s4 sx r
MD[grid]    &_s0 &_sx               ;mdg s0 sx s0 s1 s4 sx r
CINDEX  5 #F#                       ;sx mdg s0 s1 s4 sx r
CINDEX  3 #F#                       ;s0 sx mdg s0 s1 s4 sx r
MD[orig]    &_s0 &_sx               ;mdo mdg s0 s1 s4 sx r
CINDEX  2 #F#                       ;mdg mdo mdg s0 s1 s4 sx r
CINDEX  2 #F#                       ;mdo mdg mdo mdg s0 s1 s4 sx r
GT  &_mdo &_mdg                     ;gt mdo mdg s0 s1 s4 sx r
IF  &_gt                            ;mdo mdg s0 s1 s4 sx r
    SWAP                            ;mdg mdo s0 s1 s4 sx r
    SUB &_mdg &_mdo                 ;sub s0 s1 s4 sx r
    CINDEX  3 #F#                   ;s1 sub s0 s1 s4 sx r
    SWAP                            ;sub s1 s0 s1 s4 sx r
    SHPIX &_sub &_s1                ;s0 s1 s4 sx r
ELSE                                ;mdo mdg s0 s1 s4 sx r
    POP
    POP
EIF
MINDEX  5 #F#                       ;r s0 s1 s4 sx
CALL    21 &_r                      ;call21 s0 s1 s4 sx
SUB     144 &_call21                ;sub_r s0 s1 s4 sx
ABS                                 ;
SROUND  &_sub_r                     ;s0 s1 s4 sx
#
CINDEX  2 #F#                       ;s1 s0 s1 s4 sx
MDAP[rnd]   &_s1                    ;s0 s1 s4 sx
RTG                                 ;
POP
POP
POP
POP
ENDF
#arg=6,ret=0
#------------------
FDEF 24
#CHECK LEFT POINT OF LEFT STEM (s1) WITH START POINT (s0)
#IF s1 < s0 THEN SHIFT s1,s4,sx TO RIGHT
#ARG: s0, s1, s4, sx
##START                              ;s0 s1 s4 sx
#CINDEX  2   #F#         ;&_arg2_s1  ;s1 s0 s1 s4 sx
#SWAP        &_s1 &_arg1_s0          ;s0 s1 s1 s4 sx
#MD[grid]    &_s0 &_s1               ;s1 s4 sx       #FLUSH#
#LT      0   &_arg_md                ;s1 s4 sx       #FLUSH#
#IF
#    F_PUSH 64
#    SLOOP 3 #FLUSH#
#    SHPIX &_64 &_s1 &_s4 &_sx
#ELSE
#    POP
#    POP
#    POP
#EIF
#ENDF
#
#START                              ;s0 s1 s4 sx
CINDEX  2   #F#                     ;s1 s0 s1 s4 sx
SWAP        &_s1 &_s0               ;s0 s1 s1 s4 sx
MD[grid]    &_s0 &_s1               ;md s1 s4 sx
LT      0   &_md                    ;s1 s4 sx
IF
    CINDEX  3 #F#                   ;sx s1 s4 sx
    CINDEX  3 #F#                   ;s4 sx s1 s4 sx
    MD[grid]    &_s4 &_sx           ;md s1 s4 sx
    LTEQ    64 &_md                 ;lteq s1 s4 sx
    IF      &_lteq                  ;s1 s4 sx
        MINDEX  3 #F#               ;sx s1 s4
        SHPIX   64 &_sx             ;s1 s4
    ELSE
        MINDEX  3 #F#               ;sx s1 s4
        POP                         ;s1 s4
    EIF
    SHPIX 64 &_s1                   ;s4
    SHPIX 64 &_s4                   ;
ELSE
    POP
    POP
    POP
EIF
ENDF
#arg=4,ret=0
#------------------
FDEF 25
#CHECK IF s1<s0 THEN SHIFT s1 TO s0
#ARG: s0 s1
#START                          ;s0 s1
CINDEX  2 #F#                   ;s1 s0 s1
CINDEX  2 #F#                   ;s0 s1 s0 s1
MD[grid]    &_arg1_s0 &_arg2_s1 ;md s0 s1
LT 0 &_md                       ;lt s0 s1
IF  &_lt                        ;s0 s1
    SRP0        &_s0            ;s1
    DUP                         ;s1 s1
    ALIGNRP     &_s1            ;s1
ELSE
    POP         &_s0            ;s1
EIF
SRP0        &_s1
ENDF
#arg=2,ret=0
#------------------
FDEF 26
#arg=10,ret=0
#DRY END SPLINE 6 POINTS FOR ppem < 18 [10,20,40,24,16,1] 
#arg: DIRECTION, s1-2, s1-1, s1, s1+1, s1+2, s1+3, START, MID, STOP
#   DIRECTION: +1 = BOTTOM UP, -1 = TOP DOWN 
#   START:  13 MEANS FROM 9 TO 12 THE POINTS WILL FLAT
#   MID:    17 MEANS FROM 13 TO 17 THE POINTS WILL DRY LEVEL 1
#   STOP:   21 MEANS FROM 18 TO 20 THE POINTS WILL DRY LEVEL 2
#START                          ;d s-2 s-1 s s+1 s+2 s+3 start mid stop
MPPEM                           ;mppem d s-2 s-1 s s+1 s+2 s+3 start mid stop
MINDEX  11 #F#                  ;stop mppem d s-2 s-1 s s+1 s+2 s+3 start mid
LT      &_stop &_mppem          ;lt d s-2 s-1 s s+1 s+2 s+3 start mid
IF                              ;d s-2 s-1 s s+1 s+2 s+3 start mid
    MPPEM                       ;mppem d s-2 s-1 s s+1 s+2 s+3 start mid
    MINDEX 9 #F#                ;start mppem d s-2 s-1 s s+1 s+2 s+3 mid
    LT  &_start &_mppem         ;lt d s-2 s-1 s s+1 s+2 s+3 mid
    IF                          ;d s-2 s-1 s s+1 s+2 s+3 mid
        POP &_d                 ;s-2 s-1 s s+1 s+2 s+3 mid
        SRP0    &_s-2           ;s-1 s s+1 s+2 s+3 mid
        ALIGNRP &_s-1           ;s s+1 s+2 s+3 mid
        ALIGNRP &_s             ;s+1 s+2 s+3 mid
        ROLL                    ;s+3 s+1 s+2 mid
        SRP0    &_s+3           ;s+1 s+2 mid
        ALIGNRP &_s+1           ;s+2 mid
        ALIGNRP &_s+2           ;mid
        POP                     ;
    ELSE
        MPPEM                   ;mppem d s-2 s-1 s s+1 s+2 s+3 mid
        MINDEX 9 #F#            ;mid mppem d s-2 s-1 s s+1 s+2 s+3
        LT  &_mid &_mppem       ;lt d s-2 s-1 s s+1 s+2 s+3
        IF                      ;d s-2 s-1 s s+1 s+2 s+3
            EQ 1 &_d            ;eq s-2 s-1 s s+1 s+2 s+3
            IF                  ;s-2 s-1 s s+1 s+2 s+3
                f_push 4 40 48 24 24 1    ;1 40 48 8 8 1 s-2 s-1 s s+1 s+2 s+3
            ELSE
                f_push -4 -40 -48 -24 -24 -1  ;-1 -40 -48 -8 -8 -1 s-2 s-1 s s+1 s+2 s+3
            EIF
        ELSE
            EQ 1 &_d            ;eq s-2 s-1 s s+1 s+2 s+3
            IF                  ;s-2 s-1 s s+1 s+2 s+3
                f_push 1 20 24 1 8 1    ;1 20 24 4 4 1 s-2 s-1 s s+1 s+2 s+3
            ELSE
                f_push -1 -20 -24 -1 -8 -1  ;-1 -20 -24 -4 -4 -1 s-2 s-1 s s+1 s+2 s+3
            EIF
        EIF
        MINDEX 7 #F#            ;s-2 1 40 48 8 8 1 s-1 s s+1 s+2 s+3
        SWAP                    ;1 s-2 40 48 8 8 1 s-1 s s+1 s+2 s+3
        SHPIX &_1 &_s-2         ;40 48 8 8 1 s-1 s s+1 s+2 s+3
        MINDEX 6 #F#            ;s+3 40 48 8 8 1 s-1 s s+1 s+2
        SWAP                    ;40 s+3 48 8 8 1 s-1 s s+1 s+2
        SHPIX                   ;48 8 8 1 s-1 s s+1 s+2
        MINDEX 5 #F#            ;s-1 48 8 8 1 s s+1 s+2
        SWAP                    ;48 s-1 8 8 1 s s+1 s+2
        SHPIX                   ;8 8 1 s s+1 s+2
        MINDEX 4 #F#            ;s 8 8 1 s+1 s+2
        SWAP                    ;8 s 8 1 s+1 s+2
        SHPIX                   ;8 1 s+1 s+2
        ROLL                    ;s+1 8 1 s+2
        SWAP                    ;8 s+1 1 s+2
        SHPIX                   ;1 s+2
        SHPIX                   ;
    EIF
ELSE                            ;d s-2 s-1 s s+1 s+2 s+3 start mid
    POP
    POP
    POP
    POP
    POP
    POP
    POP
    POP
    POP
EIF
ENDF
#arg=10,ret=0
#------------------
FDEF 27
#ALIGN 4 POINTS BY SHIFT LEFT OR RIGHT, DETERMINE BY COMPARE GAP RATIO
#0.TEST s0,s1 IS LESS THAN 0 THEN TRY SHIFT RIGHT s1,s4
#  IF s4,sx == 0 THEN SHIFT RIGHT sx
#1.MEASURE s0,s1 (grid/orig)
#2.MEASURE s4,sx (grid/orig)
#3.IF #1>#2 TRY SHIFT LEFT ELSE TRY SHIFT RIGHT
#3.1.1      IF #1>96 AND #2<32 THEN SHIFT LEFT
#3.ELSE
#3.2.1      IF #1<32 AND #2>96 THEN SHIFT RIGHT
#ARG: s0 s1 s4 sx
#START                          ;s0 s1 s4 sx
#0.IF s1<s0 THEN SHIFT RIGHT s1,s4 AND sx IF s4>=sx
CINDEX  4 #F#                   ;sx s0 s1 s4 sx
CINDEX  4 #F#                   ;s4 sx s0 s1 s4 sx
CINDEX  4 #F#                   ;s1 s4 sx s0 s1 s4 sx
CINDEX  4 #F#                   ;s0 s1 s4 sx s0 s1 s4 sx
CALL 24 &_s0 &_s1 &_s4 &_sx     ;s0 s1 s4 sx
#1.MEASURE s0,s1 (grid/orig)
CINDEX  2 #F#                   ;s1 s0 s1 s4 sx
CINDEX  2 #F#                   ;s0 s1 s0 s1 s4 sx
MD[grid]    &_s0 &_s1           ;mdg s0 s1 s4 sx
CINDEX  3 #F#                   ;s1 mdg s0 s1 s4 sx
CINDEX  3 #F#                   ;s0 s1 mdg s0 s1 s4 sx
MD[orig]    &_s0 &_s1           ;mdo mdg s0 s1 s4 sx
CINDEX  2 #F#                   ;mdg mdo mdg s0 s1 s4 sx
CINDEX  2 #F#                   ;mdo mdg mdo mdg s0 s1 s4 sx
DIV     &_mdo &_mdg             ;div01 mdo01 mdg01 s0 s1 s4 sx
#2.MEASURE s4,sx (grid/orig)
CINDEX  7 #F#                   ;sx div01 mdo01 mdg01 s0 s1 s4 sx
CINDEX  7 #F#                   ;s4 sx div01 mdo01 mdg01 s0 s1 s4 sx
MD[grid]    &_s4 &_sx           ;mdg div01 mdo01 mdg01 s0 s1 s4 sx
CINDEX  8 #F#                   ;sx mdg div01 mdo01 mdg01 s0 s1 s4 sx
CINDEX  8 #F#                   ;s4 sx mdg div01 mdo01 mdg01 s0 s1 s4 sx
MD[orig]    &_s4 &_sx           ;mdo mdg div01 mdo01 mdg01 s0 s1 s4 sx
CINDEX  2 #F#                   ;mdg mdo mdg div01 mdo01 mdg01 s0 s1 s4 sx
CINDEX  2 #F#                   ;mdo mdg mdo mdg div01 mdo01 mdg01 s0 s1 s4 sx
DIV     &_mdo &_mdg             ;div4x mdo4x mdg4x div01 mdo01 mdg01 s0 s1 s4 sx
#3.IF #1>#2 TRY SHIFT LEFT ELSE TRY SHIFT RIGHT
MINDEX  4 #F#                   ;div01 div4x mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
SWAP                            ;div4x div01 mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
CINDEX  2 #F#                   ;div01 div4x div01 mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
CINDEX  2 #F#                   ;div4x div01 div4x div01 mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
GT  &_div4x &_div01             ;gt div4x div01 mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
IF                              ;div4x div01 mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
    #3.1.1 TRY SHIFT LEFT AND FIND LESS DIFF OF DIV
    CINDEX  2 #F#               ;div01 div4x div01 mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
    CINDEX  2 #F#               ;div4x div01 div4x div01 mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
    SUB &_div4x &_div01         ;sub014x div4x div01 mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
    ABS                         ;
    ROLL                        ;div01 sub014x div4x mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
    ROLL                        ;div4x div01 sub014x mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
    MAX &_div4x &_div01         ;max sub014x mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
    DIV &_max &_sub014x         ;res014x mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx 
    #
    MINDEX  3 #F#               ;mdg4x res014x mdo4x mdo01 mdg01 s0 s1 s4 sx
    ADD 64 &_mdg4x              ;mdg4x+64 res014x mdo4x mdo01 mdg01 s0 s1 s4 sx
    MINDEX  3 #F#               ;mdo4x mdg4x+64 res014x mdo01 mdg01 s0 s1 s4 sx
    DIV &_mdo4x &_mdg4x+64      ;div4x res014x mdo01 mdg01 s0 s1 s4 sx
    MINDEX  4 #F#               ;mdg01 div4x res014x mdo01 s0 s1 s4 sx
    SUB 64 &_mdg01              ;mdg01-64 div4x res014x mdo01 s0 s1 s4 sx
    MINDEX  4 #F#               ;mdo01 mdg01-64 div4x res014x s0 s1 s4 sx
    DIV &_mdo01 &_mdg01-64      ;div01 div4x res014x s0 s1 s4 sx 
    #
    CINDEX  2 #F#               ;div4x div01 div4x res014x s0 s1 s4 sx 
    CINDEX  2 #F#               ;div01 div4x div01 div4x res014x s0 s1 s4 sx 
    SUB &_div01 &_div4x         ;sub014x_2 div01 div4x res014x s0 s1 s4 sx  
    ABS                         ;
    ROLL                        ;div4x sub014x_2 div01 res014x s0 s1 s4 sx  
    ROLL                        ;div01 div4x sub014x_2 res014x s0 s1 s4 sx  
    MAX &_div01 &_div4x         ;max sub014x_2 res014x s0 s1 s4 sx  
    DIV &_max &_sub014x_2       ;res014x_2 res014x s0 s1 s4 sx  
    SUB 6 &_res014x_2           #FORCE LEFT
    GT  &_res014x_2 &_res014x   ;gt s0 s1 s4 sx
    #
    IF  &_gt                    ;s0 s1 s4 sx
        POP     &_s0
        SHPIX   -64 &_s1
        SHPIX   -64 &_s4
        POP     &_sx
    ELSE
        POP
        POP
        POP
        POP
    EIF
#3.ELSE
ELSE                            ;div4x div01 mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
    #3.1.2 TRY SHIFT RIGHT AND FIND LESS DIFF OF DIV
    CINDEX  2 #F#               ;div01 div4x div01 mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
    CINDEX  2 #F#               ;div4x div01 div4x div01 mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
    SUB &_div4x &_div01         ;sub014x div4x div01 mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
    ABS                         ;
    ROLL                        ;div01 sub014x div4x mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
    ROLL                        ;div4x div01 sub014x mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
    MAX &_div4x &_div01         ;max sub014x mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx
    DIV &_max &_sub014x         ;res014x mdo4x mdg4x mdo01 mdg01 s0 s1 s4 sx 
    SUB 6 &_res014x             #FORCE LEFT
    #
    MINDEX  3 #F#               ;mdg4x res014x mdo4x mdo01 mdg01 s0 s1 s4 sx
    SUB 64 &_mdg4x              ;mdg4x+64 res014x mdo4x mdo01 mdg01 s0 s1 s4 sx
    MINDEX  3 #F#               ;mdo4x mdg4x+64 res014x mdo01 mdg01 s0 s1 s4 sx
    DIV &_mdo4x &_mdg4x+64      ;div4x res014x mdo01 mdg01 s0 s1 s4 sx
    MINDEX  4 #F#               ;mdg01 div4x res014x mdo01 s0 s1 s4 sx
    ADD 64 &_mdg01              ;mdg01-64 div4x res014x mdo01 s0 s1 s4 sx
    MINDEX  4 #F#               ;mdo01 mdg01-64 div4x res014x s0 s1 s4 sx
    DIV &_mdo01 &_mdg01-64      ;div01 div4x res014x s0 s1 s4 sx 
    CINDEX  2 #F#               ;div4x div01 div4x res014x s0 s1 s4 sx 
    CINDEX  2 #F#               ;div01 div4x div01 div4x res014x s0 s1 s4 sx 
    SUB &_div01 &_div4x         ;sub014x_2 div01 div4x res014x s0 s1 s4 sx  
    ABS                         ;
    ROLL                        ;div4x sub014x_2 div01 res014x s0 s1 s4 sx  
    ROLL                        ;div01 div4x sub014x_2 res014x s0 s1 s4 sx  
    MAX &_div01 &_div4x         ;max sub014x_2 res014x s0 s1 s4 sx  
    DIV &_max &_sub014x_2       ;res014x_2 res014x s0 s1 s4 sx  
    GT  &_res014x_2 &_res014x   ;gt s0 s1 s4 sx
    IF  &_gt                    ;s0 s1 s4 sx
        POP     &_s0
        SHPIX   64 &_s1
        SHPIX   64 &_s4
        POP     &_sx
    ELSE
        POP
        POP
        POP
        POP
    EIF
EIF
ENDF
#arg=4,ret=0
#------------------
"""
    )

### MANUAL FUNCTION
def v_skel_de(s,rot=1,dr=1):
    if rot != 1: rot = -1
    if rot > 0:
        r = range(-2,4)
    else:
        r = range(2,-4,-1)
    #sp=[10,20,40,24,12,6]
    sp=[1,40,48,8,8,8]
    cmd = []
    cmd = ['MPPEM','GT 18','IF']
    for i in range(6):
        cmd.append('SHPIX %s %s' % (sp[i]*dr, s + (i-2)*rot, ))
#, 'SHPIX -12 %s' % (s-2,)
#, 'SHPIX -24 %s' % (s-1,)
#, 'SHPIX -48 %s' % (s,)
#, 'SHPIX -24 %s' % (s+1,)
#, 'SHPIX -12 %s' % (s+2,)
#, 'SHPIX -2 %s' % (s+3,)
    cmd.append('EIF')
    return '\n'.join(cmd)

def vtrde(s,b1=14,b2=17,b3=21):  #TOP RIGHT DRY END
#    return v_skel_de(s,rot=1,dr=-1)
    return 'CALL 26 -1 %s %s %s %s %s %s %s %s %s' % (s-2,s-1,s,s+1,s+2,s+3,b1,b2,b3,)

def vtlde(s,b1=14,b2=17,b3=21): #TOP LEFT DRY END
#    return v_skel_de(s,rot=-1,dr=-1)
    return 'CALL 26 -1 %s %s %s %s %s %s %s %s %s' % (s+2,s+1,s,s-1,s-2,s-3,b1,b2,b3,)

def vbrde(s,b1=14,b2=17,b3=21): #BOTTOM RIGHT DRY END
#    return v_skel_de(s,rot=-1,dr=1)
    return 'CALL 26 1 %s %s %s %s %s %s %s %s %s' % (s+2,s+1,s,s-1,s-2,s-3,b1,b2,b3,)

def vblde(s,b1=14,b2=18,b3=21): #BOTTOM LEFT DRY END
#    return v_skel_de(s,rot=1,dr=1)
    return 'CALL 26 1 %s %s %s %s %s %s %s %s %s' % (s-2,s-1,s,s+1,s+2,s+3,b1,b2,b3,)

#DRY TOP STEM IN x-axis
def drytopstem(s):
    return pl(""
        , 'SHPIX 16 %s ' % (s-1,)
        , 'SHPIX -16 %s ' % (s+1,)
        )

#DRY END 14-3 15-4 16-5
def dryend(s): #DRY TOP 14-3 15-4 16-5
    return f_dstr(s,"14-3 15-4 16-4 ")

def d_ix(s1,s2,direction="+",reverse_dir="",point2=True,ds=ds_drycurve):
    #ds = "12+1 13+2 14+1 15+1 16+1 17+1 "
    if not reverse_dir:
        if direction == "+":
            reverse_dir = '-'
        else:
            reverse_dir = '+'
    if point2:
        add2 = pl(""
            , 'SHPIX %s %s' % (int(reverse_dir+'4'),s2,)
            , f_dstr(s2,ds,direction=reverse_dir)
            )
    else:
        add2 = ""
    return pl(""
          'SHPIX %s %s' % (int(direction+'4'),s1,)
        , f_dstr(s1,ds,direction=direction)
        , add2
        )

def d_xp(s1,s2,direction="+",reverse_dir="+"):
    return d_ix(s1,s2,direction=direction,reverse_dir=reverse_dir)

def d_xm(s1,s2,direction="-",reverse_dir="-"):
    return d_ix(s1,s2,direction=direction,reverse_dir=reverse_dir)

def d_x1(s1):
    return d_ix(s1,0,point2=False)

def d_x2(s1):
    return d_ix(s1,0,direction="-",point2=False)

#DRY INNER RIGHT
def d_ir(s,direction="+"):
    return d_ix(s+1,s-1,direction=direction)

#DRY OUTER RIGHT
def d_or(s,direction="-"):
    return d_ir(s,direction=direction)

def d_il(s):
    return d_or(s)

def d_ol(s):
    return d_ir(s)

def h_if_lt0_shift_right(s0,s1,s4,sx):
    #TEST IF s1<s0 THEN SHIFT s1,s4,sx TO RIGHT
    #END FUNC WITH rp0 AT s1
    #r=ROUND_VALUE, s0=POINT 0, s1=LEFT SPLINE OF LEFT STEM, 
    #   s4=RIGHT SPLINE OF RIGHT STEM, sx=END POINT
    return 'CALL 24 %s %s %s %s' % (s0,s1,s4,sx)

def h_if_lt0_set0(s0,s1):
    ##MEASURE DISTANCE FROM s1 TO s0, IF < 0 THEN SET TO s0
    return pl(""
        , "CALL 25 %s %s" % (s0, s1,)
        )

def h_main_1(sx, s1,fx12,s2, r=main_round, s0=0):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,a=2)
    if callable(fx12):
        x12 = fx12(s2)
    else:
        x12 = mdrpmb(s2,fx12)
    if not s0:
        s0 = sx-1
    return pl(""
        , mdapr(sx)
        , 'SROUND %s' % (r,)
        , ip_round(s0,sx,s1)
        , 'RTG'
        , x12
        , 'CALL 27 %s %s %s %s' % (s0,s1,s2,sx,)
#, mdrp0mrw(s2)
#, 'SROUND %s' % (r-1,)
#, ip_round(s0,s2,s1)
#, 'RTG'
        , srp0(s1)
        , add1
        , x12
        , add2
        )

def h_main_01(sx, s1, s2,fx23,s3, ds31="", ds3x="", r=main_round, s0=0, min3=True):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,a=2)
    s3,add3 = gen_alignrp(s3)
    sx,addx = gen_alignrp(sx)
    if callable(fx23):
        x23 = fx23(s2)
    else:
        x23 = mdrpmb(s2,fx23,direction='-')
    if not s0:
        s0 = sx-1
    if min3:
        m3 = 1
        fx3x = mdrp0mrg
    else:
        m3 = 0
        fx3x = mdrp0rg
    return pl(""
        , 'CALL 23 %s %s %s %s %s %s #F#' % (s0,s1,s3,sx,r,m3,)
        , h_if_lt0_shift_right(s0,s1,s3,sx) 
        , f_dstr(s1,ds31)
        , add1
        , srp0(s3)
        , add3
        , x23
        , add2
        #
        , srp0(s1)  #BACKWARD COMPAT
        )

def ht_main_01(sx, s1, s2,fx23,s3, r=thai_round, ds31="", s0=0):
    return h_main_01(sx, s1, s2,fx23,s3, r=r, ds31=ds31, s0=s0)

def h_main_10(sx, s1,fx12,s2, s3, r=main_round, ds3x="", ds31="", s0=0, min3=True,shift3=False):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,a=2)
    s3,add3 = gen_alignrp(s3)
    sx,addx = gen_alignrp(sx)
    if callable(fx12):
        x12 = fx12(s2)
    else:
        x12 = mdrpmb(s2,fx12)
    if not s0:
        s0 = sx-1
    if min3:
        fx3x = mdrp0mrw
        m3 = 1
    else:
        fx3x = mdrp0rw
        m3 = 0
    if shift3:
        if type(shift3) == type(1):
            as3 = 'SHPIX -%s %s' % (shift3,s3,)
        else:
            as3 = 'SHPIX -%s %s' % (shift_edge,s3,)
        as1= mdapr(s1)
    else:
        as3 = ''
        as1 = ''
    return pl(""
        , 'CALL 23 %s %s %s %s %s %s #F#' % (s0,s1,s3,sx,r,m3,)
#        , mdapr(sx)
#        , fx3x(s3)
#        , 'CALL 21 %s' % (r,)
#        , 'SROUND &_call21'
#        , mdrp0rg(s1)
#        , 'RTG'
        , as3
        , h_if_lt0_shift_right(s0,s1,s3,sx)
        , f_dstr(s1,ds31)
        , add1
        , x12
        , add2
        , srp0(s3)
        , f_dstr(s3,ds3x)
        , add3
        #
        , srp0(s1)      #BACKWARD COMPAT.
        )

def ht_main_10(sx, s1,fx12,s2, s3, r=thai_round, ds3x="", ds31="", s0=0, min3=True):
    return h_main_10(sx, s1,fx12,s2, s3, r=r, ds3x=ds3x, ds31=ds31, s0=s0, min3=min3)

def h_skel_2(sx, s1,fx12,s2, s3,fx34,s4, ds41="", ds4x="", r=main_round, s0=0, min4=True,shift4=False):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,a=2)
    s3,add3 = gen_alignrp(s3,a=2)
    s4,add4 = gen_alignrp(s4)
    sx,addx = gen_alignrp(sx)
    if not s0:
        s0 = sx-1
    if callable(fx12):
        x12 = fx12(s2)
    else:
        x12 = mdrpmb(s2,fx12)
    if callable(fx34):
        x34 = fx34(s3)
    else:
        x34 = mdrpmb(s3,fx34,direction="-")
    if min4:
        fx4x = mdrp0mrw
        m4 = 1
    else:
        fx4x = mdrp0rw
        m4 = 0
    if shift4:
        as4 = 'SHPIX -%s %s' % (shift_edge,s4,)
        as1 = mdapr(s1)
    else:
        as4 = ''
        as1 = ''
    return pl(""
        , 'CALL 23 %s %s %s %s %s %s #F#' % (s0,s1,s4,sx,r,m4,)
#        , mdapr(sx)
#        , fx4x(s4)
#        , 'CALL 21 %s' % (r,)
#        , 'SROUND &_call21'
#        , mdrp0rg(s1)
#        , 'RTG'
        , 'CALL 27 %s %s %s %s' % (s0,s1,s4,sx,)
#        , h_if_lt0_shift_right(s0,s1,s4,sx)
        , srp0(s1)
        , as1
        , f_dstr(s1,ds41)
        , add1
        , x12
        , add2
        #
        , srp0(s4)
        , f_dstr(s4,ds4x)
        , add4
        , x34
        , add3
        #
        , srp0(s1)      #BACKWARD COMPAT.
        )


def h_main_2(sx, s1,fx12,s2, s3,fx34,s4, ds41="",ds4x="",r=main_round,s0=0,min4=True,shift4=False):
    return h_skel_2(sx, s1,fx12,s2, s3,fx34,s4, ds41=ds41,ds4x=ds4x,r=r,s0=s0,min4=min4,shift4=shift4)

def ht_main_2(sx, s1,fx12,s2, s3,fx34,s4, ds41="",ds4x="",r=thai_round,s0=0,min4=True):
    return h_skel_2(sx, s1,fx12,s2, s3,fx34,s4, ds41=sum_dstr(""+ds41),ds4x=ds4x,r=r,s0=s0,min4=min4)

def ht_main_head(sx, s2,s3,s4, s5,s6, s7,s8, ds41="",ds4x="",r=thai_round, s0=0):
    s2,add2 = gen_alignrp(s2)
    s3,add3 = gen_alignrp(s3,a=2)
    s4,add4 = gen_alignrp(s4,a=2)
#    s5,add5 = gen_alignrp(s5)
#    s6,add6 = gen_alignrp(s6,a=2)
    sa5,temp = gen_alignrp(s5)
    if not s0:
        s0 = sx-1
    return pl(""
        , h_main_2(sx, s5,tstemw_1,s6, s7,tstemw_2,s8, ds41=sum_dstr(""+ds41),ds4x=ds4x, r=r, s0=s0)
        , mdrp0rg(s2,ds_in_head2stem+ds_dryhead,direction='-')
        , add2
        , headstem_1(s3)
        , add3
        , hsph_1(s4)
        , add4
        , srp0(sa5)
        )

def h_edge_2(sx, s1,s2, r=main_round, min2=False, shift2=True, wide1=False, s0=0):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2)
    if not s0:
        s0 = sx - 1
    if min2:
        x2 = mdrp0mrw(s2)
    else:
        x2 = mdrp0rw(s2)
    if shift2:
        as2 = 'SHPIX -%s %s' % (shift_edge,s2,)
    else:
        as2 = ''
    if wide1:
        x1 = pl(""
            , 'SROUND %s' % (144-r,)
            , mdrp0rg(s1)
            , mdapr(s1)
            , 'RTG'
            , h_if_lt0_set0(s0,s1)
            )
    else:
        x1 = pl(""
            , 'SROUND %s' % (r,)
            , mdapr(s1)
            , 'RTG'
            )
    return pl(""
        , mdapr(sx)
        , x2
        , as2
        , add2
        , x1
        , add1
        )

def h_notch_ko(s0,s1, s2,s3,s4,s5):
    return pl(""
        , srp0(s1)
        , 'SROUND 69'
        , mdrp0rg(s2)
        , 'RTG'
        , h_if_lt0_set0(s0,s2)
        , srp0(s1)
        , mdrpg(s5,"14-1 15-3 16-5 23-4 24-4 25-4 ")
        , add_ip(s2,s5,[s3,s4])
        , f_dstr(s3,ds_tstemw+"14-4 15-4 16-4 ")
        , f_dstr(s4,ds_tstemw+"14-4 15-6 16-8 ",direction="-")
        )

    
def h_serif(s2):
    return pl(""
        , 'RDTG'
        , mdrprg(s2)
        , 'RTG'
        )


#HEAD TURN LEFT, HINT FROM LEFT TO RIGHT, ROUND LEFT STEM SPLINE
#THO THAHAN
def h_head_1(s2,s3,s4,ds4=ds_out_head2stem):
    s2,add2 = gen_alignrp(s2,a=2)
    s3,add3 = gen_alignrp(s3,a=2)
    s4,add4 = gen_alignrp(s4)
    return pl(""
        , mdrp0rg(s4,ds4)
        , add4
        , headstem_2(s3)
        , add3
        , hsph_2(s2)
        , add2
        )

#HEAD TURN LEFT, HINT FROM LEFT TO RIGHT, ROUND RIGHT STEM SPLINE
#NGO NGU
def h_head_1r(s2,s3,s4,ds2=ds_out_head2stem):
    s2,add2 = gen_alignrp(s2)
    s3,add3 = gen_alignrp(s3,a=2)
    s4,add4 = gen_alignrp(s4,a=2)
    return pl(""
        , mdrp0rg(s2,ds2,direction="-")
        , add2
        , headstem_1(s3)
        , add3
        , hsph_1(s4)
        , add4
        )

#HEAD TURN RIGHT, HINT FROM RIGHT TO LEFT, ROUND LEFT STEM SPLINE
#THO THUNG
def h_head_2(s2,s3,s4,ds2=ds_in_head2stem):
    s2,add2 = gen_alignrp(s2)
    s3,add3 = gen_alignrp(s3,a=2)
    s4,add4 = gen_alignrp(s4,a=2)
    return pl(""
        , mdrp0rg(s2,ds2+ds_dryhead)
        , add2
        , headstem_2(s3)
        , add3
        , hsph_2(s4)
        , add4
        )

def h_head_khai(s0,s1,s2, s3,s4,s5, sip, sr, s6,s7):
    return pl(""
        , ip_round(s0,s1,s2)
        , v_head_1(s3,s4,s5)
        , f_ip(sip)
        , ip_round(s2,sr,s6,"13-8 17-8 20-8 ")
        , tstemwc_thin_1(s7)
        )

def h_head_khuat(s0,s1,s2, s3,s4,s5, sx,s6,s7, sip):
    return pl(""
#        , 'RDTG'
#        , ip_round(s0,s1,s2)
#        , 'RTG'
#        , mdrpmb(s3,"9-8 10-8 "+ds_headstem)
#        , mdrp0mrg(s4,"9-8 10-8 12-8 13-8 19-8 20-8 21-8 28+4 29-2 30-2")
#        , headstem_1(s5)
, ip_round(s0,s1,s5)
, headstem_2(s4)
, hsph0_2(s3)
, mdrpg(s2)
        , ip_round(s2,sx,s6,"13-8 ")
        , tstemwc_thin_1(s7)
        , add_ip(s2,s7,sip)
        )

def v_head_1(s2,s3,s4, fx=headstem_1,fx3=hsph0_1,dir3="+"):
    s2,add2 = gen_alignrp(s2,a=2)
    s3,add3 = gen_alignrp(s3)
    s4,add4 = gen_alignrp(s4,a=2)
    return pl(""
        , fx(s2)
        , add2
        , fx3(s3)
        , add3
        , fx(s4)
        , add4
        )

def v_head_2(s2,s3,s4):
    return v_head_1(s2,s3,s4,fx=headstem_2,fx3=hsph0_2,dir3="-")

def v_head_khai(s2,s3,s4):
    return pl(""
        , 'SROUND 68'
        , mdrp0rg(s4)
        , 'RTG'
        , mdapr(s4)
        , hsph_1(s2)
        , headstem_1(s3)
        )

def v_head_khuat(s1, s2,s3, s4,s5,s6,s7):
    return pl(""
        , mdrp0mrb(s2)
        , mdapr(s2)
        , tstemt_thin_2(s3)
        , srp0(s1)
        , 'RDTG'
        , mdrp0rg(s4,"9-8 10-8 ")
        , 'RTG'
        , mdapr(s4)
        , shift(16,s4)
        , v_head_2(s5,s6,s7)
        )

def vb0(s1):
    s1,add1 = gen_alignrp(s1)
    return pl(""
        , 'MPPEM'
        , 'LT %s' % (ppem_allow_shoot,)
        , 'IF'
        , 'ROFF'
        , 'EIF'
        , mdrp0rg(s1)
        , add1
        , 'RTG'
        )

def vb_skel(s0, s1,fx12,s2):
    s2,add2 = gen_alignrp(s2,2)
    return pl(""
        , srp0(s0)
        , vb0(s1)
        , fx12(s2)
        , add2
        )

def vb_0(s0, s1,s2):
    return vb_skel(s0,s1,estemtc_num_1,s2)
        
def vb_C(s0, s1,s2):
    return vb_skel(s0,s1,ecstemtc_1,s2)
        
def vb_b(s0, s1,s2):
    return vb_skel(s0,s1,estemtc_max_1,s2)
        
def vb_c(s0, s1,s2):
    return vb_skel(s0,s1,estemtc_1,s2)
        
def vb_ngo(s0, s1,s2):
    return vb_skel(s0,s1,tstemtc_1,s2)
        
def vb_1(s0, s1, fx1=estemt_num_1):
    s1,add1 = gen_alignrp(s1,2)
    return pl(""
        , mdapr(s0)
        , fx1(s1)
        , add1
        )

def vb_B(s0, s1):
    return vb_1(s0,s1,fx1=ecstemt_1)

def vb_I(s0, s1):
    return vb_1(s0,s1,fx1=ecstemt_mid_1)

def vb_z(s0, s1):
    return vb_1(s0,s1,fx1=estemt_1)

def vb_khai(s0, s1):
    return vb_1(s0,s1,fx1=tstemt_1)

def vb_ching(s0, s1, s2):
    return pl(""
        , vb_1(s0,s1,fx1=tstemt_mid_1)
        , vb0(s2)
        )

def v_top(s0, cvt1,s1, sip, s2, ds2=""):
    #IF s1 = 0 WILL SWITCH TO ZONE 1
    #IF s2 = 0 WILL NOT TOUCH s2
    s0,add0 = gen_alignrp(s0)
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2)
    if sip:
        add_sip = pl(srp2(s0), f_ip(sip))
    else:
        add_sip = ""
    if s1 == 0: #LET s1=0, NO REFERENCE POINT, USE ZONE0=0 AS REF.POINT
        add01 = 'SZP0 0'
        add02 = 'SZP0 1'
    else:       #HAS REFERENCE POINT
        add01 = ""
        add02 = ""
    if s2 == 0:
        fx12 = ""
    else:
        fx12 = pl(""
        , 'MPPEM'
        , 'LT %s' % (ppem_allow_shoot)
        , 'IF'
        , 'ROFF'
        , 'EIF'
        , mdrp0rg(s2)
        , 'RTG'
        )
    return pl(""
        , mdapr(s0)
        , add0
        , add01
        , miapr(cvt1,s1)
        , add1
        , add_sip
        , fx12
        , add02
        , f_dstr(s2,ds2)
        , 'SHPIX -2 %s' % (s2,)
        , add2
        )

def v_ngo(s0, s1, sip, s2): #s1=0
    return v_top(s0, 'evheight', s1, sip, s2)

def v_1(s0, s1, sip): #s2=0
    return v_top(s0, 'evheight_num', s1, sip, 0)

def v_A(s0, s1, sip): #s2=0
    return v_top(s0, 'ecvheight', s1, sip, 0)

def v_i(s0, s1, sip): #s2=0
    return v_top(s0, 'evheight', s1, sip, 0)

def v_top_stem(s0, cvt1, s1, sip, s2,s3, fx23=estemtc_2):
    s3, add3 = gen_alignrp(s3,a=2)
    if callable(fx23):
        x23 = fx23(s3)
    else:
        x23 = mdrpb(s3)
    return pl(""
        , v_top(s0, cvt1,s1, sip, s2)
        , x23
        , 'SHPIX 4 %s' % (s3,)
        , add3
        )

def v_ko(s0, s1, sip, s2,s3):
    return v_top_stem(s0, 'evheight', s1, sip, s2,s3, fx23=tstemtc_2)

def v_kwai(s0, s1, sip, s2,s3):
    s3, add3 = gen_alignrp(s3,a=2)
    return pl(""
        , v_top_stem(s0, 'evheight', s1, sip, s2,s3, fx23=tstemtc_2)
        , f_dstr(s3,'9+1 10+1 11+1 12+1 13+1 14+1 15+1 16+1 ')
        , add3
        )

def v_ro(s0, s1, sip, s2,s3, s4,s5):
    s4,add4 = gen_alignrp(s4)
    s5,add5 = gen_alignrp(s5,a=2)
    return pl(""
        , v_top_stem(s0, 'evheight', s1, sip, s2,s3, fx23=tstemt_num0_2)
        , mdrp0rw(s4)
        , mdapr(s4,"12-8 ")
        , add4
        , tstemt_thin_2(s5)
        , add5
        )

def v_khai(s0, s1, sip, s2,s3):
    return v_top_stem(s0, 'evheight', s1, sip, s2,s3, fx23=tstemt_thin_2)

def v_a(s0, s1, sip, s2,s3, fx23=estemtc_autothin_2):
    return v_top_stem(s0, 'evheight', s1, sip, s2,s3, fx23=fx23)

def v_c(s0, s1, sip, s2,s3, fx23=estemtc_2):
    return v_top_stem(s0, 'evheight', s1, sip, s2,s3, fx23=fx23)

def v_e(s0, s1, sip, s2,s3, fx23=estemt_mid_2):
    return v_top_stem(s0, 'evheight', s1, sip, s2,s3, fx23=fx23)

def v_n(s0, s1, sip, s2,s3, fx23=estemtc_max_2):
    return v_top_stem(s0, 'evheight', s1, sip, s2,s3, fx23=fx23)

def v_t(s0, s1, sip, s3, fx23=estemt_t_2): #s2=0
    return v_top_stem(s0, 'evheight', s1, sip, 0,s3, fx23=fx23)

def v_z(s0, s1, sip, s3, fx23=estemt_2): #s2=0
    return v_top_stem(s0, 'evheight', s1, sip, 0,s3, fx23=fx23)

def v_B(s0, s1, sip, s3, fx23=ecstemt_2): #s2=0
    return v_top_stem(s0, 'ecvheight', s1, sip, 0,s3, fx23=fx23)

def v_C(s0, s1, sip, s2,s3, fx23=ecstemtc_2):
    return v_top_stem(s0, 'ecvheight', s1, sip, s2,s3, fx23=fx23)

def v_I(s0, s1, sip, s3, fx23=ecstemt_mid_2): #s2=0
    return v_top_stem(s0, 'ecvheight', s1, sip, 0,s3, fx23=fx23)

def v_0(s0, s1, sip, s2,s3, fx23=estemtc_num_2):
    return v_C(s0, s1, sip, s2,s3, fx23=fx23)

def v_5(s0, s1, sip, s3, fx23=estemt_num_2):
    return v_C(s0, s1, sip, 0,s3, fx23=fx23)

def vt_num(s0, s1, sip, s2,s3, fx23=tstemtc_num_2):
    return v_top_stem(s0, 'tvheight_num', s1, sip, s2,s3, fx23=fx23)

def v_skel_top(cvt1,fx2,s2):
    s2,add2 = gen_alignrp(s2)
    return pl(""
        , 'SZP0 0'
        , miapr(cvt1,0)
        , fx2(s2)
        , 'SZP0 1'
        , add2
        )

def v_sara(s2):
    return v_skel_top('evheight',mdrp0rw,s2)


def shift(n,s1):    #SHIFT POINT IN REAL DISTANCE NOT DEPEND ON PPEM
    return pl(""
        , 'MPPEM'           #CURRENT POINT PER EM
        , 'LT %s' % (ppem_allow_shoot,) #ALLOW SHIFT WHEN ppem > 32
        , 'IF'
            , 'MPPEM'
            , 'MUL %s' % (n,)   #NUMBER OF PIXEL TO SHIFT
            , 'PUSHB 32'        #=EmSize/64 =2048/64 =32
            , 'SWAP'
            , 'DIV '
            , 'SHPIX %s' % (s1,) #POINT TO SHIFT
        , 'EIF'
        )


pseudo_code_dict = {
    'exclam':
        packline(""
        , h_main_1(9, 1,ecstemw_1,3)
        , mdrpg(5)
        , mdrpg(6)
        , srp0(3)
        , mdrpg(4)
        , mdrpg(7)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecvheight0_1(7)
        , srp0(0)
        , mdrp0mrb(3)
        , mdrp0mrw(4)
        , iy()
        ),

    'quotedbl':
        packline(""
        , srp0(9)
        , mdrp0mrw(7)
#        , ecstemwc0_2(6)
#        , mdrp0mrw(3)
#        , 'RDTG'
#        , mdapr(3)
#        , 'RTG'
#        , ecstemwc0_2(2)
, estemw_thin0_2(6)
, mdrp0mrw(3)
, estemw_thin_2(2)
        , ix()
        #y
        , sy()
        , mdapr(7)
        , alignrp(3)
        , mdrprg(4)
        , shprp2(0)
        , iy()
        ),

    'numbersign':
        packline(""
        , mdapr(22)
        , mdrprg(11)
        , f_ip([14,18])
        , mdrp0rg(26)
        , mdrprg(7)
        , f_ip([5,1])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(4)
        , ecvheight0_1(19)
        , alignrp(15)
        , f_ip([20,24])
        , mdapr(20)
        , alignrp(17)
        , alignrp(13)
        , estemw_sign_2(23)
        , shprp2(29)
        , shprp2(10)
        , mdapr(24)
        , alignrp(28)
        , alignrp(9)
        , estemw_sign_2(27)
        , shprp2(2)
        , shprp2(6)
        , iy()
, sx()
, fo_mirp(14,5,14,'estemw_sign',[15])
, 'SHPIX -8 15'
, f_dstr(15,"14-8 15-8 16-8 ")
, fo_mirp(18,1,18,'estemw_sign',[19])
, 'SHPIX 8 18'
, 'SHPIX 8 1'
, f_dstr(18,"14-8 15-8 16-8 ",direction='-')
, f_dstr(1,"14-8 15-8 16-8 ",direction='-')
, fp_mdrp(14,5,14,[13,10,9,6])
, fp_mdrp(14,5,15,[16,30,31,3,4])
, fp_mdrp(18,1,18,[17,29,28,2])
, fp_mdrp(18,1,19,[20,23,24,27,0])
        ),

    'dollar':
        packline(""
        , h_main_2(49, (13,5),estemw_1,45, 37,estemw_2,30)
#        , srp0(30)
#        , mdrprg(23)
#        , ip_round(45,37,1)
#        , alignrp(10)
#        , alignrp(42)
#        , alignrp(17)
#        , mdrpg(33)
#        , shprp2(40)
#        , shprp2(26)
#        , shprp2(18)
        , ix()
        #y
        , sy()
        , mdapr(2)
        , alignrp(33)
        , estemtc_1(9)
        , shprp2(34)
        , mdrprg(0)
        , mdapr(19)
        , alignrp(16)
        , estemtc_2(26)
        , shprp2(42)
        , mdrprg(18)
#        , add_ip(26,9,[41])
#        , srp0(41)
#        , estemw_2(40)
#        , f_ip([27,10])
, add_ip(19,9,[41,27])
, add_ip(26,2,[10,40])
        , iy()
        , vtrde(22)
        , vblde(5)
        ),

    'percent':
        packline(""
        , h_main_2(53, 31,estemt_1,49, 19,estemt_2,13)
        , mdrp0rg(43)
        , f_ip([1])
        , estemt_1(37)
        , srp0(13)
        , mdrp0rg(25)
        , f_ip([3])
        , estemt_2(7)
        , srp0(1)
        , estemtc_1(0)
        , srp0(3)
        , estemtc_2(2)
        , ix()
        #y
        , sy()
        , mdapr(4)
        , alignrp(0)
        , mdrpb(16)
        , mdrp0rg(10)
        , mdrpb(22)
        , mdapr(34)
        , alignrp(3)
        , mdrpb(46)
        , mdrp0rg(28)
        , mdrpb(40)
        , iy()
        ),

    'ampersand':
        packline(""
        , h_main_2(55, 8,ecstemw_1,39, 27,ecstemw_2,28)
        , mdrp0rg(14)
        , ecstemwc_1(51)
        , mdrp0rg(45)
        , f_ip([11,42,23,36])
        , ecstemwc_1(20)
        , srp0(28)
        , mdrp0g(0)
        , ix()
        #y
        , sy()
        , v_C(0, 0, [27,11,42,23,36,35,24,31,2], 17, 48, fx23='')
        , srp0(5)
        , vb0(5)
        , ecstemtc_1(32)
        , mdapr(27)
        , iy()
, sx()
, fo_mirp(0,53,0,'estemw',[1])
, 'SHPIX 8 1'
, fp_mdrp(0,53,0,[42,23,24,31])
, fp_mdrp(0,53,1,[12,11,36,35,2])
        ),

    'quotesingle':
        packline(""
        , mdapr(6)
        , mdrp0mrw(3)
        , estemw_thin_2(2)
        , ix()
        #y
        , sy()
        , mdapr(3)
        , mdrprg(0)
        , iy()
        ),

    'parenleft':
        packline(""
#        , h_main_2(15, 4,estemwc_1,11, (1,7),estemt_2,(0,8), ds41="20+8 21+8 22+8 ")
, h_main_10(15, 4,estemwc_1,11, (0,8))
, srp0(0)
, estemt_2(1)
, shprp2(7)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdapr(8)
        , iy()
        ),

    'parenright':
        packline(""
#        , h_main_2(15, (1,7),estemt_1,(0,8), 4,estemw_2,11, ds41="17+8 ")
, h_main_01(15, (1,7), 4,estemwc_1,11)
, srp0(1)
, estemt_1(0)
, shprp2(8)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdapr(8)
        , iy()
        ),

    'asterisk':
        packline(""
        , 'SROUND %s' % (main_round,)
        , ip_round(18,19,1)
        , 'RTG'
        , alignrp(9)
        , mdrpg(3)
        , shprp2(7)
        , mdrpg(4)
        , shprp2(6)
        , mdrpg(5)
        , mdrp0mb(0)
        , alignrp(10)
        , mdrpg(16)
        , shprp2(12)
        , mdrpg(15)
        , shprp2(13)
        , mdrpg(14)
        , ix()
        #y
        , sy()
        , mdapr(10)
        , mdrprg(0)
        , f_ip([2,3,4,5,6,7,8,11,12,13,14,15,16,17])
        , iy()
        ),

    'plus':
        packline(""
        , 'SROUND %s' % (main_round,)
        , mdapr(1)
        , alignrp(5)
        , mdrprg(3)
        , 'RTG'
        , estemt0_1(11)
        , shprp2(7)
        , 'SROUND %s' % (main_round,)
        , mdrprg(10)
        , 'RTG'
        , ix()
        #y
        , sy()
        , 'SROUND %s' % (144-main_round,)
        , mdapr(8)
        , alignrp(5)
        , 'SROUND %s' % (main_round,)
        , mdrprg(7)
        , 'RTG'
        , estemt0_2(11)
        , alignrp(2)
        , 'SROUND %s' % (main_round,)
        , mdrprg(0)
        , 'RTG'
        , iy()
        ),

    'comma':
        packline(""
        , mdapr(3)
        , ecstemwc_2(2)
        , mdrp0rg(1)
        , mdrpmb(0)
        , ix()
        #y
        , sy()
        , mdapr(3)
        , mdrprg(0)
        , iy()
        ),

    'hyphen':
        packline(""
        , srp0(5)
        , mdrp0mrw(0)
        , 'SROUND %s' % (main_round,)
        , ip_round(4,0,1)
        , 'RTG'
        , ix()
        #y
        , sy()
        , 'SROUND %s' % (144-main_round,)
        , mdapr(3)
        , 'RTG'
        , ecstemtc_2(0)
        , iy()
        ),

    'period':
        packline(""
        , 'SROUND %s' % (main_round,)
        , mdapr(1)
        , 'RTG'
        , mdrpmb(3)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpmb(3)
        , iy()
        ),

    'slash':
        packline(""
        , mdapr(1)
        , estemt_num_1(0)
        , mdapr(3)
        , estemt_num_2(2)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdapr(3)
        , iy()
        ),

    'colon':
        packline(""
        , h_main_1(9, (1,5),'',(3,7))
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpmb(3)
        , mdapr(4)
        , mdrpmb(7)
        , iy()
        ),

    'semicolon':
        packline(""
        , mdapr(3)
        , ecstemwc_2(2)
        , mdrp0rg(1)
        , mdrpmb(0)
        , srp0(3)
        , mdrp0rg(5)
        , mdrpmb(7)
        , ix()
        #y
        , sy()
        , mdapr(3)
        , mdrprg(0)
        , mdapr(4)
        , mdrpmb(7)
        , iy()
        ),

    'less':
        packline(""
        , h_edge_2(8, 1, (0,4), shift2=False)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdapr(3)
        , add_ip(0,3,[1,2,5])
        , iy()
, fo_mirp(0,1,0,'estemt',[6])
, fo_mirp(3,2,3,'estemt',[4])
, sy()
, add_ip(4,0,[1])
, add_ip(3,6,[2])
, sx()
, fp_mdrp(3,2,4,[5])
, sy()
, add_ip(1,2,[5])
        ),

    'greater':
        packline(""
        , h_edge_2(8, (0,3), 6, shift2=False)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdapr(4)
        , add_ip(0,4,[2,5,6])
        , iy()
, fo_mirp(0,6,0,'estemt',[1])
, fo_mirp(4,5,4,'estemt',[3])
, sy()
, add_ip(4,1,[5])
, add_ip(3,0,[6])
, sx()
, fp_mdrp(4,5,3,[2])
, sy()
, add_ip(5,6,[2])
        ),

    'equal':
        packline(""
        , srp0(9)
        , mdrp0mrw(0)
        , alignrp(4)
        , mdrprg(2)
        , shprp2(6)
        , ix()
        #y
        , sy()
        , mdapr(3)
        , estemtc_2(0)
        , mdrp0rg(7)
        , estemtc_2(4)
        , iy()
        ),

    'question':
        packline(""
        , h_main_01(31, 17, 11,ecstemwc_2,24)
        , ip_round(17,24,1)
        , mdrprg(5)
        , ecstemwc0_1(3)
        , mdrprg(4)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , v_C(0, 0, [], 21,14)
        , srp0(0)
        , mdrp0mrg(3)
        , mdrpmrw(4)
        , iy()
        , vtrde(18)
        ),

    'at':
        packline(""
        , srp0(57)
        , mdrp0mrw(9)
        , estemt_mid_2(29)
        , mdrprg(42)
        , 'SROUND %s' % (main_round,)
        , ip_round(56,9,3)
        , 'RTG'
        , estemt_mid0_1(35)
        , mdrp0mrw(18)
, mdrpmrb(53)
        , ip_round(53,29,13)
        , alignrp(48)
        , alignrp(24)
, mdrpmrb(25)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , estemt_mid_1(38)
        , mdapr(6)
        , estemt_mid_2(32)
        , ip_round(32,38,24)
        , mdrp0rg(21)
        , estemt_mid_2(50)
        , ip_round(50,38,12)
        , mdrpmrb(26)
        , mdrp0rw(15)
        , estemt_mid_1(45)
        , iy()
        ),

    'zero':
        packline(""
        , h_main_2(25, 3,estemwc_num_1,21, 15,estemwc_num_2,9)
        , ix()
        #y
        , sy()
        , v_0(25, 0,[],6,18)
        , vb_0(25,0,12)
        , iy()
, d_il(21)
, d_ir(15)
        ),

    'one':
        packline(""
        , h_main_1(16, (3,11),estemw_num_1,12)
        , mdrprg(7)
        , mdrprg(1)
        , srp0(12)
        , mdrprg(14)
        , ix()
        #y
        , sy()
        , v_1(0,12,[])
        , mdrp0rg(7)
        , estemt_1(8)
        , mdrpg(4)
        , vb_1(0,(14,3))
        , iy()
        ),

    'two':
        packline(""
        , h_main_2(26, 1,ecstemwc_1,23, 6,estemwc_num_2,19)
        , mdrprg(12)
        , srp0(19)
        , 'SROUND %s' % (main_round,)
        , ip_round(19,26,24)
        , 'RTG'
        , add_ip(23,19,[21])
        , ix()
        #y
        , sy()
        , v_0(0, 0,[],16,9)
        , vb_1(0,24)
        , srp0(24)
        , mdrpg(2)
        , iy()
, d_ir(6)
        ),

    'three':
        packline(""
        , h_main_01(42, 3, 10,estemwc_num_2,38)
        , mdrprg(25)
        , ip_round(3,10,14)
        , srp0(38)
        , mdrp0rg(32)
        , estemwc_num_2(19)
        , ix()
        #y
        , sy()
        , v_0(41, 0,[], 29,22)
        , vb_0(41, 0,7)
        , 'SROUND 73'
        , ip_round(29,7,15)
        , 'RTG'
        , estemtc_2(14)
        , f_ip([35])
        , iy()
, d_ir(19)
, d_ir(10)
        ),

    'four':
        packline(""
#        , h_main_01(15, 3, (1,11),estemw_num_2,(10,6))
#        , 'SROUND %s' % (main_round,)
#        , ip_round(0,15,9)
#        , 'RTG'
, mdapr(15)
, mdrp0mrw(9)
, h_main_01(9, 3, (1,11),estemw_num_2,(10,6),s0=14)
        , ix()
        #y  
        , sy()
        , v_1(0,6,[7])
        , mdapr(7)
        , alignrp(13)
        , estemt_num_2(10)
        , shprp2(3)
        , iy()
, sx()
, fo_mirp(3,6,4,'estemt',[13])
, fo_mirp(6,3,12,'estemt',[5])
, sy()
, fo_mirp(3,6,13,'estemt',[4])
, fo_mirp(6,3,5,'estemt',[12])
        ),

    'five':
        packline(""
        , h_main_2(31, 16,estemw_num_1,20, 10,estemwc_num_2,(27,19))
        , mdrprg(4)
        , ix()
        #y  
        , sy()
        , v_5(30, 18, [], 19)
        , vb_0(30,0,7)
        , mdapr(30)
        , ip_round(18,7,24)
        , estemtc_num_2(13)
        , iy()
        , vblde(3)
, d_ir(10)
        ),

    'six':
        packline(""
        , h_main_2(38, 3,estemwc_num_1,(16,34), 28,estemwc_num_2,22)
        , srp0(22)
        , mdrprg(10)
        , ix()
        #y  
        , sy()
        , v_0(37, 0,[],6,13)
        , vb_0(37,0,25)
        , ip_round(6,25,19)
        , estemtc_num_2(31)
        , iy()
        , vtrde(9)
, d_ir(28)
, d_ix(15,35)
        ),

    'seven':
        packline(""
        , h_edge_2(8, 3, 5, min2=True, shift2=False)
        , ix()
        #y  
        , sy()
        , v_5(0, 5, [], (2,6))
        , iy()
, sx()
, fo_mirp(6,0,6,'estemw_num',[2])
, 'SHPIX %s 2' % (shift_slant,)
, fp_mdrp(6,0,2,[1])
        ),

    'eight':
        packline(""
        , h_main_2(49, 3,estemwc_num_1,33, 27,estemwc_num_2,21)
        , mdrp0g(9)
        , estemwc_num_1(45)
        , srp0(21)
        , mdrp0g(15)
        , estemwc_num_2(39)
        , add_ip(3,21,[6,30,36,18])
        , ix()
        #y  
        , sy()
        , v_0(48, 0, [], 12,42)
        , vb_0(48,0,24)
        , add_ip(12,24,[36])
        , add_ip(42,0,[30])
        , iy()
#, fo_mirp(30,29,30,'estemt_t',[47])
#, 'SHPIX -%s 47' % (shift_slant,)
#, 'SHPIX %s 30' % (shift_slant,)
#, fo_mirp(36,47,36,'estemt_t',[29])
#, 'SHPIX %s 29' % (shift_slant,)
#, 'SHPIX -%s 36' % (shift_slant,)
, sy()
        , add_ip(30,36,[6,18])
, d_il(45)
, d_il(33)
, d_ir(39)
, d_ir(27)

        ),

    'nine':
        packline(""
        , h_main_2(38, 16,estemwc_num_1,34, (28,10),estemwc_num_2,22)
        , mdrprg(4)
        , ix()
        #y  
        , sy()
        , v_0(38, 0,[], 19,31)
        , vb_0(38,0,7)
        , ip_round(31,0,13)
        , estemtc_num_1(25)
        , iy()
        , vblde(3)
, d_il(34)
, d_ix(29,9)
        ),

    'A':
        packline(""
        , h_edge_2(12,5,0)
        , add_ip(5,0,[6,7,9])
        , ix()
        #y
        , sy()
        , v_A((0,4), 7, [8])
        , mdapr(8)
        , ecstemt_2(2)
        , iy()
, sx()
, fo_mirp(5,6,5,'ecstemw',[4])
, fo_mirp(0,7,0,'ecstemw',[1])
, sx()
, 'SHPIX -%s 4' % (shift_slant,)
, 'SHPIX %s 1' % (shift_slant,)
, add_ip(5,1,[6])
, add_ip(4,0,[7])
, sy()
, fp_mdrp(5,6,4,[9])
, sy()
, sx()
, add_ip(6,7,[9])
, fp_mdrp(4,9,5,[6])
, fp_mdrp(1,9,0,[7])
, fp_mdrp(4,9,4,[3,10])
, fp_mdrp(1,9,1,[2,8])
        ),

    'B':      
        packline(""
        , h_main_2(34, 1,ecstemw_1,(22,31), 18,ecstemwc_2,12)
        , srp0(12)
        , mdrp0mrg(6)
        , ecstemwc_2(27)
        , ix()
        #y
        , sy()
        , v_B(0, 3,[],30)
        , vb_B(0,15)
        , 'SROUND 73'
        , ip_round(3,15,24,"20-8 ")
        , 'RTG'
        , ecstemt_mid_2(21)
        , f_ip([9])
        , iy()
        ),

    'C':      
        packline(""
        , h_main_10(27, 3,ecstemwc_1,16, (23,10))
        , ix()
        #y
        , sy()
        , v_C(26, 0,[],6,13)
        , vb_C(26,0,19)
        , iy()
        ),

    'D':      
        packline(""
        , h_main_2(19, 1,ecstemw_1,16, 12,ecstemwc_2,6)
        , ix()
        #y
        , sy()
        , v_B(0, 3,[],15)
        , vb_B(0,9)
        , iy()
        ),

    'E':      
        packline(""
        , h_main_10(13, 1,ecstemw_1,(9,5), 11)
        , add_ip(1,11,[8,4])
        , ix()
        #y
        , sy()
        , v_B(0, 3,[],4)
        , vb_B(0, 11)
        , ip_round(3,11,7)
        , ecstemt_2(8)
        , iy()
        ),

    'F':      
        packline(""
        , h_main_10(11, 1,ecstemw_1,(9,5), 4)
        , add_ip(1,4,[8])
        , ix()
        #y
        , sy()
        , v_B(0, 3,[7],4)
        , mdapr(7)
        , ecstemt_2(8)
        , iy()
        ),

    'G':      
        packline(""
        , h_main_2(31, 3,ecstemwc_1,16, 22,ecstemw_2,26)
        , srp0(26)
        , mdrprg(10)
        , ip_round(16,22,24)
        , ix()
        #y
        , sy()
        , v_C(30, 0,[],6,13)
        , vb_C(30, 0,19)
        , ip_round(6,19,25)
        , ecstemt_mid_2(24)
        , iy()
        ),

    'H':      
        packline(""
        , h_main_2(13, 5,ecstemw_1,(3,7), (1,9),ecstemw_2,11)
        , ix()
        #y
        , sy()
        , v_A((0,4), (11,7),[9])
        , mdapr(9)
        , ecstemt_2(2)
        , iy()
        ),

    'I':      
        packline(""
        , h_main_1(13, 3,ecstemw_1,9)
        , mdrprg(1)
        , shprp2(5)
        , srp0(9)
        , mdrprg(7)
        , shprp2(11)
        , ix()
        #y
        , sy()
        , v_I(0, 7,[],(8,4), fx23=ecstemt_mid_2)
        , vb_I(0,(11,3))
        , iy()
        ),

    'J':      
        packline(""
        , h_main_01(19, 4, 10,ecstemw_2,14)
        , mdrprg(12)
        , ix()
        #y
        , sy()
        , v_I(18, 14,[],11)
        , vb_C(18, 0,7)
        , iy()
        ),

    'K':      
        packline(""
        , h_main_10(13, 5,ecstemw_1,(3,7), 0, min3=False,shift3=True)
        , add_ip(3,0,[10,11])
        , ix()
        #y
        , sy()
        , v_A((0,4), (10,7),[])
        , iy()
, sx()
, fo_mirp(0,11,0,'ecstemw',[1])
, 'SHPIX %s 1' % (shift_slant,)
, fp_mdrp(0,11,1,[2])
, sx()
        , add_ip(5,1,[9])
, sy()
, fp_mdrp(10,3,10,[2,11])
, fp_mdrp(10,3,9,[8])
, sx()
, fp_mdrp(0,11,1,[2])
        ),

    'L':      
        packline(""
        , h_main_10(7, 1,ecstemw_1,3, 5, min3=False,shift3=True)
        , ix()
        #y
        , sy()
        , v_A(0, 3,[])
        , srp0(0)
        , ecstemt_1(5)
        , iy()
        ),

    'M':      
        packline(""
        , h_main_2(14, 7,estemw_1,5, 1,ecstemw_2,12)
        , add_ip(5,1,[10,4,3])
        , ix()
        #y
        , sy()
        , v_A((0,6), (12,9),[])
        , iy()
, sx()
, fo_mdrp(5,4,5,[9])
, fo_mdrp(2,3,2,[11])
, sy()
, fo_mdrp(9,10,9,[5])
, fo_mdrp(11,10,11,[2])
, sy()
, f_dstr(2,"9+4 10+4 11+4 12+4 13+4 14+4 15+4 16+4 ")
, mdapr(4)
, mdapr(3)
, fp_mdrp(5,4,9,[10])
, sx()
, fp_mdrp(2,3,11,[10])
, sy()
, fp_mdrp(10,9,4,[5])
        ),

    'N':      
        packline(""
        , h_main_2(11, 4,estemw_1,2, 7,estemw_2,9)
        , ix()
        #y
        , sy()
        , v_A((0,3), (9,6),[])
        , iy()
, sx()
, fo_mdrp(5,0,2,[6])
, fo_mdrp(0,5,7,[1])
#, f_dstr(6,"12+1 13+1 14+2 15+2 16+3 ")
#, f_dstr(1,"12-1 13-1 14-2 15-2 16-3 ")
, sy()
, fo_mdrp(6,7,6,[2])
, fo_mdrp(1,2,1,[7])
#, f_dstr(2,"12-1 13-1 14-2 15-2 16-3 ")
#, f_dstr(7,"12+1 13+1 14+2 15+2 16+3 ")
, sy()
, f_dstr(2,"9+4 10+4 11+4 12+4 13+4 14+4 15+4 16+4 ")
, f_dstr(7,"9-4 10-4 11-4 12-4 13-4 14-4 15-4 16-4 ")
        ),

    'O':      
        packline(""
        , h_main_2(25, 3,ecstemwc_1,21, 15,ecstemwc_2,9)
        , ix()
        #y
        , sy()
        , v_C(24, 0,[],6,18)
        , vb_C(24, 0, 12)
        , iy()
        ),

    'P':      
        packline(""
        , h_main_2(21, 1,ecstemw_1,(10,18), 14,ecstemwc_2,6)
        , ix()
        #y
        , sy()
        , v_B(0, 2,[11],17)
        , mdapr(11)
        , ecstemt_2(9)
        , iy()
        ),

    'Q':      
        packline(""
        , h_main_2(40, 3,ecstemwc_1,36, 30,ecstemwc_2,9)
        , ip_round(36,30,25)
        , ecstemt_1(12)
        , srp0(9)
        , mdrprg(18)
        , ix()
        #y
        , sy()
        , v_C(39, 0,[],6,33)
        , vb_C(39, 0,27)
        , f_ip([12])
        , mdrp0rg(22)
        , ecstemtc_1(15)
        , iy()
        ),

    'R':      
        packline(""
        , mdapr(0)
        , h_main_2(0, 7,ecstemw_1,(5,23), 19,ecstemwc_2,12, s0=25)
        , add_ip(5,12,[15])
        , ix()
        #y
        , sy()
        , v_B((0,6), 9,[16],22)
        , mdapr(16)
        , ecstemt_2(4)
        , f_ip([15])
        , iy()
, sx()
, fo_mirp(0,15,0,'ecstemw',[1])
, fp_mdrp(0,15,1,[2])
        ),

    'S':      
        packline(""
        , h_main_2(37, 15,ecstemwc_1,28, 10,ecstemwc_2,33)
        , mdrprg(3)
        , srp0(33)
        , mdrprg(22)
        , add_ip(15,33,[12,13,30,31])
        , ix()
        #y
        , sy()
        , v_C(36, 0,[13],18,25)
        , vb_C(36,0,7)
, f_dstr(13,"14+3 15+3 16+3 17-1 ")
, srp0(13)
, mdrpg(12)
, fo_mirp(12,13,12,'ecstemwc',[31])
, 'SHPIX -%s 31' % (shift_slant)
, 'UTP 12'
        , iy()
        ),

    'T':      
        packline(""
        , mdapr(9)
        , mdapr(3)
        , mdrp0rg(1)
        , ecstemw0_1(7)
        , mdrp0rg(5)
        , 'MD[grid] 8 5'
        , 'MD[grid] 8 9'
        , 'GT'
        , 'IF'
        , 'SHPIX -64 1'
        , 'SHPIX -64 7'
        , 'SHPIX -128 5'
        , 'EIF'
        , ix()
        #y
        , sy()
        , v_B(0, 5, [], (6,2))
        , iy()
        ),

    'U':      
        packline(""
        , h_main_2(19, 3,ecstemw_1,5, 12,ecstemw_2,14)
        , ix()
        #y
        , sy()
        , v_A(18, (14,5),[])
        , vb_C(18,0,9)
        , iy()
        ),

    'V':      
        packline(""
        , h_edge_2(8, 2,6)
        , add_ip(2,6,[1,0,4])
        , ix()
        #y
        , sy()
        , v_A(0, (5,3), [])
        , iy()
, sx()
, fo_mirp(3,4,2,'ecstemw',[3])
, 'SHPIX -%s 3' % (shift_slant,)
, fo_mirp(5,4,6,'ecstemw',[5])
, 'SHPIX %s 5' % (shift_slant,)
, sx()
, add_ip(2,5,[1])
, add_ip(3,6,[0])
, sy()
, fp_mdrp(2,1,3,[4])
        ),

    'W':      
        packline(""
        , h_edge_2(14, 5,12)
        , add_ip(5,12,[7,2,10])
        , ix()
        #y
        , sy()
        , v_A((0,3), (11,8,6), [])
        , iy()
, sx()
, fo_mirp(6,7,5,'ecstemw',[6])
, 'SHPIX -%s 6' % (shift_slant,)
, fo_mirp(11,10,12,'ecstemw',[11])
, 'SHPIX %s 11' % (shift_slant,)
, fp_mdrp(6,3,5,[4])
, fp_mdrp(11,1,12,[0])
, sy()
, fp_mdrp(5,4,6,[7])
, fp_mdrp(12,0,11,[10])
, sx()
, add_ip(5,11,[8])
, add_ip(6,12,[9])
, sy()
, fp_mdrp(4,8,3,[2])
        ),

    'X':      
        packline(""
        , h_edge_2(13, (6,4),(10,0))
        , add_ip(6,10,[8,2])
        , ix()
        #y
        , sy()
        , v_A((0,3), (10,7), [])
        , iy()
, sx()
, fo_mirp(6,2,6,'ecstemw',[7])
, 'SHPIX -%s 7' % (shift_slant,)
, fo_mirp(10,2,10,'ecstemw',[9])
, 'SHPIX %s 9' % (shift_slant,)
, sx()
, srp0(7)
, alignrp(3)
, srp0(9)
, alignrp(1)
, fp_mdrp(6,1,6,[5])
, fp_mdrp(10,3,10,[11])
, sy()
, fp_mdrp(9,4,9,[8])
, fp_mdrp(1,6,1,[2])
        ),

    'Y':      
        packline(""
        , h_main_1(10, 1,ecstemw_1,8)
        , f_ip([5])
        , mdrp0g(3)
        , srp0(8)
        , mdrp0g(7)
        , ix()
        #y
        , sy()
        , v_A(0, (7,4),[8,2])
        , iy()
, sx()
, fo_mirp(3,2,3,'ecstemw',[4])
, 'SHPIX -%s 4' % (shift_slant,)
, fo_mirp(7,8,7,'estemw',[6])
, 'SHPIX %s 6' % (shift_slant,)
, sy()
, fp_mdrp(3,2,4,[5])
        ),

    'Z':      
        packline(""
        , h_edge_2(11, (1,4), (6,9), min2=True, shift2=False, wide1=True)
        , ix()
        #y
        , sy()
        , v_B(0, 6,[],3)
        , vb_B(0,9)
        , iy()
, sx()
, fo_mirp(1,6,2,'ecstemw',[8])
, 'SHPIX -%s 8' % (shift_slant,)
, fo_mirp(1,6,7,'ecstemw',[3])
, 'SHPIX %s 3' % (shift_slant,)
, sy()
, fo_mirp(7,8,8,'ecstemw',[2])
, fo_mirp(2,3,3,'ecstemw',[7])
        ),

    'bracketleft':      
        packline(""
        , h_main_10(9, 1,estemw_1,5, (7,4))
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpmb(7)
        , mdapr(3)
        , mdrpmb(4)
        , iy()
        ),

    'backslash':
        packline(""
        , mdapr(2)
        , estemt_num_1(3)
        , mdapr(0)
        , estemt_num_2(1)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdapr(3)
        , iy()
        ),

    'bracketright':
        packline(""
        , h_main_01(9, (1,5), 3,estemw_2,7)
        , ix()
        #y
        , sy()
        , mdapr(1)
        , mdrpmb(2)
        , mdapr(6)
        , mdrpmb(5)
        , iy()
        ),

    'asciicircum':      
        packline(""
        , h_main_2(8, 4,estemwc_1,3, 1,estemw_2,0)
        , add_ip(3,1,[2])
        , srp0(2)
        , mdrpb(5)
        , mdrpb(6)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(3)
        , mdapr(8)
        , ecvheight0_1(6)
        , mdrpb(2,ds_estemt, direction="-")
        , iy()
        ),

    'underscore':      
        packline(""
        , mdapr(0)
        , mdapr(1)
        , ix()
        #y
        , sy()
        , mdapr(3)
        , mdrpb(0)
        , iy()
        ),

    'grave':
        packline(""
        , mdapr(2)
        , ecstemw_1(3)
        , mdrp0rg(0)
        , mdrpmb(1)
        , ix()
        #y
        , sy()
        , mdapr(3)
        , mdrprg(0)
        , iy()
        ),

    'a':      
        packline(""
        , h_main_2(39, 8,estemwc_1,35, (30,11,2),estemw_2,26)
        , mdrprg(19)
        , ix()
        #y
        , sy()
        , v_a(0, 0,[12,2],23,16)
        , vb_c(0,5,27)
        , mdapr(12)
        , estemt_mid_2(31)
        , iy()
        , vtlde(20)
, d_il(35)
, d_x1(14)
, d_x2(30)
        ),

    'b':
        packline(""
        , h_main_2(31, 1,estemw_1,(26,16,3), 20,estemwc_2,10,r=main_round+1)
        , ix()
        #y
        , sy()
        , v_n(0, 0,[4,16],7,23)
        , evheight_b0_1(3)
        , vb_b(0,13,17)
        , iy()
, d_ir(20)
        ),

    'c':
        packline(""
        , h_main_10(27, 3,estemwc_1,16, (23,10))
        , ix()
        #y
        , sy()
        , v_c(26, 0,[],6,13)
        , vb_c(26,0,19)
        , iy()
        , vtrde(9)
        , vbrde(23)
, d_il(16)
        ),

    'd':
        packline(""
        , h_main_2(31, 8,estemwc_1,27, (2,21,15),estemw_2,16,r=main_round+1)
        , ix()
        #y  
        , sy() 
        , v_n(0, 0,[14,2],11,24)
        , evheight_b0_1(16)
        , vb_b(0,5,17)
        , iy()
, d_il(27)
        ),  

    'e':
        packline(""
        , h_main_2(30, 3,estemwc_1,(11,28), 22,estemwc_2,10)
        , srp0(10)
        , mdrprg(18)
        , ix()
        #y  
        , sy()
        , v_e(29, 0,[],6,25)
        , vb_c(29,0,15)
        , ip_round(6,15,28)
        , estemt_mid_2(11)
        , iy()
        , vbrde(19,b1=11)
, d_ix(27,13)
, d_x1(23)
        ),

    'f':
        packline(""
        , h_main_1(25, (1,5),estemw_1,(23,19))
        , ip_round(24,1,3)
        , 'SROUND %s' % (main_round,)
        , ip_round(23,25,22)
        , 'SROUND 70'
        , mdrprg(13)
        , 'RTG'
        , ix()
        #y  
        , sy()
        , v_t(0, (21,5),[], (22,2))
        , mdrp0rg(9)
        , estemtc_2(16)
        , iy()
        , vtrde(12,b1=17)
, d_x1(18)
        ),

    'g':
        packline(""
        , h_main_2(43, 3,estemwc_1,39, (26,33,10),estemw_2,11,r=main_round+1)
        , mdrprg(18)
        , ix()
        #y
        , sy()
        , v_n(42, 10,[9,26],6,36)
        , vb_b(42,0,29)
        , srp0(42)
        , mdrp0rg(15)
        , estemtc_1(22)
        , iy()
        , vblde(18)
, d_il(39)
        ),

    'h':
        packline(""
        , h_main_2(21, 10,estemw_1,(8,12), 1,estemw_2,19, r=main_round-1) 
        , ix()
        #y
        , sy()
        , v_n((0,9), 0,[13,8],16,5)
        , evheight_b0_1(12)
        , iy()
, d_x1(3)
        ),

    'i':
        packline(""
        , h_main_1(9, (1,5),estemw_1,(3,7))
        , ix()
        #y
        , sy()
        , v_i(0, 3, [])
        , mdrp0mrw(4)
        , tstemt_1(7)
        , iy()
        ),

    'j':
        packline(""
        , h_main_1(23, (10,19),estemw_1,(14,21))
        , h_serif(12)
        , mdrp0rg(4)
        , ix()
        #y
        , sy()
        , v_t(22, 14, [], 11)
        , mdrp0mrw(18)
        , tstemt_1(21)
        , vb_c(22,0,7)
        , iy()
        , vblde(3)
, d_x2(9)
        ),

    'k':
        packline(""
        , h_main_10(13, 5,estemw_1,(3,7), 0, min3=False,shift3=False,r=main_round+2,ds31="19+8 ")
        , add_ip(3,0,[10,11])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(4)
        , evheight0_1(10)
        , evheight_b0_1(7)
        , iy()
, sx()
, fo_mirp(0,11,0,'estemw',[1])
, 'SHPIX %s 1' % (shift_slant,)
, fp_mdrp(0,11,1,[2])
, sx()
        , add_ip(5,1,[9])
, sy()
, fp_mdrp(10,3,10,[2,11])
, fp_mdrp(10,3,9,[8])
, sx()
, fp_mdrp(0,11,1,[2])
        ),  

    'l':
        packline(""
        , h_main_1(5, 1,estemw_1,3)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , evheight_b0_1(3)
        , iy()
        ),

    'm':
        packline(""
        , h_main_2(39, 22,estemw_1,(20,24), 1,estemw_2,37,ds41="10+8 11+8 13+8 14-8 16-8 17-8 20-8 23+8 25+8 26+8 28+8 29-8 31-8 32-8 33+8 35+8 37+8 38+8 41+8 ",ds4x="19-8 21+8 22-8 39-8 ")
        , ip_round(22,1,13)
        , estemw_1(11)
        , f_ip([31])
        , ix()
        #y
        , sy()
        , v_n((0,12,21), 24,[25,31],(28,34),(17,5))
        , iy()
, d_xp(15,3)
        ),

    'n':
        packline(""
        , h_main_2(21, 10,estemw_1,(8,12), 1,estemw_2,19, r=main_round-1)
        , ix()
        #y
        , sy() 
        , v_n((0,9), 12,[13],16,5)
        , iy()
, d_x1(3)
        ),

    'o':
        packline(""
        , h_main_2(25, 3,estemwc_1,21, 15,estemwc_2,9)
        , ix()
        #y
        , sy() 
        , v_c(24, 0,[],6,18)
        , vb_c(24, 0,12)
        , iy()
, d_il(21)
, d_ir(15)
        ),

    'p':
        packline(""
        , h_main_2(31, 1,estemw_1,(16,26,3), 20,estemwc_2,10,r=main_round+1)
        , ix()
        #y
        , sy()
        , v_n(30, 3,[4,16],7,23)
        , evheight_p0_1(0)
        , vb_b(30, 13,17)
        , iy()
, d_ir(20)
        ),

    'q':
        packline(""
        , h_main_2(31, 8,estemwc_1,27, (2,21,15),estemw_2,16,r=main_round+1)
        , ix()
        #y  
        , sy()
        , v_n(30, 15,[14,2],11,24)
        , evheight_p0_1(1)
        , vb_b(30, 5,17)
        , iy()
, d_il(27)
        ),

    'r':
        packline(""
        #, h_main_10(19, 1,estemw_1,(17,3), 11)
        , h_main_10(19, 1,estemw_1,(17,3), 11, shift3=31,min3=False,r=main_round-1,ds31="")
#        , h_main_10(19, 1,estemw_1,(17,3), 11, ds3x="14+8 16+8 18+8 19+8 20+8 22+8 23+8 ")
#, h_main_1(19, 1,estemw_1,(17,3))
#, mdrp0rg(11)
#, 'MD[grid] 19 11'
#, 'LTEQ 0'
#, 'IF'
#, 'SHPIX -64 11'
#, 'EIF'
        , ix()
        #y
        , sy()
        , mdapr(0)
        , v_n(0, 3,[4,17],7,14)
        , iy()
        ),

    's':
        packline(""
        , h_main_2(37, 15,estemwc_1,28, 10,estemwc_2,33)
        , mdrprg(4)
        , srp0(33)
        , mdrprg(22)
        , add_ip(15,33,[12,13,30,31])
        , ix()
        #y
        , sy()
        , v_c(36, 0,[13],18,25)
        , vb_c(36, 0,7)
, f_dstr(13,"14+2 15+2 16+2 17-2 ")
, srp0(13)
, mdrpg(12)
, fo_mirp(12,13,12,'tstemw',[31])
, 'SHPIX -%s 31' % (shift_slant)
, 'UTP 12'
        , iy()
        , vtrde(21,b1=11)
        , vblde(3,b1=11)
        ),

    't':
        packline(""
        , h_main_1(25, (3,7),estemw_1,(13,9))
        , ip_round(24,3,5)
        , 'SROUND %s' % (main_round,)
        , ip_round(13,25,12)
        , alignrp(20)
        , 'RTG'
        , ix()
        #y  
        , sy()
        , v_t(24, (11,7),[],(12,4))
        , mdrprg(9)
        , vb_c(24, 0,17)
        , iy()
        , vbrde(21,b1=17)
        ),

    'u':
        packline(""
        , h_main_2(21, 8,estemw_1,10, (17,1),estemw_2,19, r=main_round-1)
        , ix()
        #y
        , sy() 
        , v_i(0, (19,10),[2])
        , vb_b(0,5,14)
        , iy()
, d_x2(12)
        ),

    'v':
        packline(""
        , h_edge_2(8, 2,6)
        , add_ip(2,6,[1,0,4])
        , ix()
        #y
        , sy()
        , v_i(0, (5,3),[])
        , iy()
, sx()
, fo_mirp(2,1,2,'estemw',[3])
, 'SHPIX -%s 3' % (shift_slant,)
, fo_mirp(6,0,6,'estemw',[5])
, 'SHPIX %s 5' % (shift_slant,)
, sx()
, add_ip(2,5,[1])
, add_ip(3,6,[0])
, sy()
, fp_mdrp(2,1,3,[4])

        ),

    'w':
        packline(""
        , h_edge_2(14, 5,12)
        , add_ip(5,12,[7,2,10])
        , ix()
        #y
        , sy()
        , v_i((0,3), (11,8,6),[])
        , iy()
, sx()
, fo_mirp(6,7,5,'estemw',[6])
, 'SHPIX -%s 6' % (shift_slant,)
, fo_mirp(11,10,12,'estemw',[11])
, 'SHPIX %s 11' % (shift_slant,)
, fp_mdrp(6,3,5,[4])
, fp_mdrp(11,1,12,[0])
, sy()
, fp_mdrp(5,4,6,[7])
, fp_mdrp(12,0,11,[10])
, sx()
, add_ip(5,11,[8])
, add_ip(6,12,[9])
, sy()
, fp_mdrp(4,8,3,[2])
        ),

    'x':
        packline(""
        , h_edge_2(13, (6,4),(10,0))
        , add_ip(6,10,[8,2])
        , ix()
        #y
        , sy()
        , v_i((0,3), (10,7),[])
        , iy()
, sx()
, fo_mirp(6,2,6,'estemw',[7])
, 'SHPIX -%s 7' % (shift_slant,)
, fo_mirp(10,2,10,'estemw',[9])
, 'SHPIX %s 9' % (shift_slant,)
, sx()
, srp0(7)
, alignrp(3)
, srp0(9)
, alignrp(1)
, fp_mdrp(6,1,6,[5])
, fp_mdrp(10,3,10,[11])
, sy()
, fp_mdrp(9,4,9,[8])
, fp_mdrp(1,6,1,[2])
        ),

    'y':
        packline(""
        , h_edge_2(21,12,16)
        , mdrprg(4)
        , add_ip(12,16,[14])
        , ix()
        #y
        , sy()
        , v_i(20, (15,13),[])
        , vb_c(20, 0,7)
        , iy()
        , vblde(3)
, sx()
, fo_mirp(13,14,12,'estemw',[13])
, 'SHPIX -%s 13' % (shift_slant,)
, fo_mirp(15,14,16,'estemw',[15])
, 'SHPIX %s 15' % (shift_slant,)
, sx()
, add_ip(12,15,[9])
, add_ip(13,16,[18])
, fp_mdrp(16,18,16,[17])
, fp_mdrp(15,9,15,[10,11])
, sy()
, fp_mdrp(15,9,15,[11,14])
, sx()
, fp_mdrp(15,9,15,[11])
, sy()
, f_dstr(14,"17-8 27-8 ")
        ),

    'z':
        packline(""
        , h_edge_2(11, (1,4), (6,9), min2=True, shift2=False, wide1=False)
        , ix()
        #y
        , sy()
        , v_z(0, 6,[],3)
        , vb_z(0, 9)
        , iy()
, sx()
, fo_mirp(1,6,2,'estemw',[8])
, 'SHPIX -%s 8' % (shift_slant,)
, fo_mirp(1,6,7,'estemw',[3])
, 'SHPIX %s 3' % (shift_slant,)
, sy()
, fo_mirp(1,6,8,'estemw',[2])
, fo_mirp(1,6,3,'estemw',[7])
        ),

    'braceleft':      
        packline(""
        , srp0(38)
        , mdrp0mrw(0)
        , alignrp(20)
        , ip_round(37,0,9)
        , mdrprb(28,ds_ecstemw)
        , ip_round(10,20,4)
        , alignrp(14)
        , estemw_1(31)
        , shprp2(24)
        , ix()
        #y
        , sy()
        , mdapr(10)
        , estemt_1(9)
        , f_ip([28])
        , mdrp0rg(19)
        , mdrpmb(20)
        , srp0(9)
        , mdrp0rg(0)
        , mdapr(0)
        , mdrpmb(36)
        , iy()
        ),

    'bar':      
        packline(""
        , h_main_1(5, 1,estemw_1,3)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdapr(3)
        , iy()
        ),

    'braceright':      
        packline(""
        , srp0(38)
        , mdrp0mrw(29)
        , mdrprb(10,ds_ecstemw,direction="-")
        , ip_round(37,29,1)
        , alignrp(18)
        , ip_round(1,29,33)
        , alignrp(23)
        , estemw_2(6)
        , shprp2(13)
        , ix()
        #y
        , sy()
        , mdapr(28)
        , estemt_1(29)
        , f_ip([10])
        , mdrp0rg(19)
        , mdrpmb(18)
        , srp0(29)
        , mdrp0rg(1)
        , mdapr(1)
        , mdrpmb(2)
        , iy()
        ),

    'asciitilde':      
        packline(""
        , srp0(25)
        , mdrp0mrw(21)
        , ip_round(24,21,8)
        , add_ip(8,21,[2,3,14,15])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , tstemt_num0_1(17)
        , mdrp0mrg(12)
        , tstemt_num_2(5)
        , iy()
        ),

# BEGIN THAI
    'uni0E01':      #KO KAI
        packline(""
        , ht_main_2(28, 15,tstemw_1,13, 1,tstemw_2,26)
        , h_notch_ko(27,15, 20,8,19,9)
        , ix()
        #y
        , sy()
        , v_ko((0,14), 0,[8,9,10,13,16,19,20],23,5)
        , iy()
, d_xp(7,3)
        ),

    'uni0E02':      #KHO KHAI
        packline(""
        , ht_main_2(52, 3,tstemw_1,34, 36,tstemw_2,38,ds41="9-8 ")
        , h_serif(1)
        , h_head_khai(51,3, 23, 48,42,17, [14], 35, 9,29)
        , ix()
, f_dstr(25,"18-6 ")
        #y
        , sy()
        , v_khai(0, 38, [], 26,12)
        , v_head_khai(45,39,20)
        , vb_khai(0,(36,3))
, add_ip(26,36,[5])
, add_ip(12,0,[30])
        , iy()
        ),

    'uni0E03':      #KHO KHUAT
        packline(""
        , ht_main_2(55, 3,tstemw_1,37, 39,tstemw_2,41,ds41="9-8 ")
        , h_serif(1)
        , h_head_khuat(54,3,24, 51,45,18, 39,9,32, [27,28,29,11,12,13])
        , ix()
        #y
        , sy()
        , v_khai(0, 41, [], (29,27),(11,13))
        , v_head_khuat(29, 28,12, 15,48,42,21)
        , vb_khai(0, (39,3))
, add_ip(29,39,[5])
, add_ip(11,0,[33])
        , iy()
        ),

    'uni0E04':      #KHO KHWAI
        packline(""
        , ht_main_2(53, 33,tstemwc_1,8, 1,tstemw_2,39, r=thai_round-2)
        , mdrp0rg(27)
        , tstemw_1(25)
        , f_ip([11])
        , srp0(33)
        , mdrp0rg(17,ds_dryhead+"14+8 19+8 ")
        , headstem_2(43)
        , hsph0_2(49)
        , mdrpg(12)
        , add_ip(12,17,[22])
        , ix()
        #y
        , sy()
        , v_kwai((0,26), 0,[14],36,5)
        , 'SROUND 70'
        , mdapr(14,ds_dryhead)
        , 'RTG'
        , v_head_2(46,40,20)
        , iy()
        , 'SHPIX 32 22'
, d_xp(7,3)
        ),

    'uni0E05':      #KHO KHON
        packline(""
        , ht_main_2(57, 35,tstemwc_1,10, 1,tstemw_2,43, r=thai_round-2)
        , mdrp0rg(29)
        , tstemw_1(27)
        , f_ip([13])
        , srp0(35)
        , mdrp0rg(19,ds_dryhead+"14+8 19+8 ")
        , headstem_2(47)
        , hsph0_2(53)
        , mdrpg(14)
        , add_ip(14,19,[24])
        , add_ip(10,1,[38,39,40,5,6,7])
        , ix()
        #y
        , sy()
        , v_kwai((0,28), 0,[],[40,38],[5,7])
        , mdrp0mrg(39)
        , mdapr(39)
        , tstemt_2(6)
        , 'RDTG'
        , mdapr(6)
        , 'RTG'
        , 'SROUND 70'
        , ip_round(6,1,16,ds_dryhead)
        , 'RTG'
        , shift(16,16)
        , v_head_2(50,44,22)
        , iy()
, d_xp(9,3)
        ),

    'uni0E06':      #KHO RAKHANG
        packline(""
        , ht_main_2(76, 13,tstemw_1,47, [51,1],tstemw_2,53)
        , mdrp0rg(10,"17+8 ")
        , headstem_1(72)
        , hsph0_1(68)
        , mdrpg(5)
        , h_head_khuat(75,13,34, 63,57,28, 51,19,42, [37,38,39,21,22,23])
        , ix()
        #y
        , sy()
        , v_khai(0, 53, [], (39,37),(21,23))
        , v_head_khuat(39, 38,22, 25,60,54,31)
        , vb_ching(0,51,7)
        , headstem_2(66)
        , mdrp0rg(69)
        , alignrp(4)
        , headstem_2(13)
        , shprp2(48)
, add_ip(39,51,[15])
, add_ip(21,0,[43])
        , iy()
        ),

    'uni0E07':      #NGO NGU
        packline(""
        , ht_main_01(45, 6, 16,tstemw_2,28)
        , srp0(28)
        , h_head_1r(22,41,35)
        , srp0(28)
        , mdrpg(11)
        , add_ip(6,11,[8])
        , srp0(16)
        , mdrpg(2)
, fp_mdrp(11,8,2,[5])
        , ix()
        #y
        , sy()
        , v_ngo(45, 0,[7],25)
        , v_head_2(38,32,19)
        , vb_ngo(45, 0,13)
        , mdapr(7)
        , iy()
, fp_mdrp(13,7,0,[6])
        ),

    'uni0E08':      #CHO CHAN
        packline(""
        , ht_main_01(53, 29, 22,tstemw_2,36)
        , ip_round(29,22,9,ds_dryhead,direction='-')
        , headstem_1(49)
        , hsph0_1(43)
        , mdapr(43)
        , mdrpb(14)
        , srp0(36)
        , mdrpg(17)
        , srp0(22)
        , mdrpg(2)
        , ix()
        #y
        , sy()
        , v_ko(52, 0,[12],33,26)
        , vb_ngo(52, 0,19)
        , 'SROUND 74'
        , mdapr(12,ds_dryhead)
        , 'RTG'
        , v_head_2(46,40,6)
        , iy()
        , vtlde(30)
, d_x1(24)
, sx()
, fp_mdrp(17,14,2,[4])
        ),

    'uni0E09':      #CHO CHING
        packline(""
        , ht_main_head(71, 7,55,49, 1,(13,0), 17,31,ds4x=" ",ds41=" ")
        , srp0(31)
        , mdrp0rg(35)
        , v_head_2(61,67,41)
        , srp0(70)
        , mdrpmrw(24)
        , ix()
        #y
        , sy()
        , v_ko(0, 0,[10],28,21)
        , mdapr(10,ds_dryhead)
        , v_head_2(52,46,4)
        , vb_ching(0, 14,38)
        , v_head_1(58,64,17)
        , add_ip(38,17,[32,43])
        , f_dstr(17,"9+8 10+8 ")
        , f_dstr(43,"9+8 10+8 ")
        , f_dstr(32,"9+8 10+8 ")
        , iy()
        , vtlde(25)
, d_x1(19)
        ),

    'uni0E0A':      #CHO CHANG
        packline(""
        , ht_main_2(65, 3,tstemw_1,34, 36,tstemw_2,51,ds4x="18+8 ")
        , h_serif(1)
        , h_head_khai(64,3, 23, 61,55,17, [14], 35, 9,29)
        , 'RTDG'
        , ip_round(29,36,40)
        , 'RDTG'
        , tstemw_1(48)
        , 'RTG'
        , ip_round(0,65,45)
        , ix()
, f_dstr(25,"18-6 ")
        #y
        , sy()
        , v_khai(0, 0, [40,41,48], 26,12)
        , v_head_khai(58,52,20)
        , vb_khai(0, (36,3))
, add_ip(26,36,[5])
, add_ip(12,0,[30])
        , iy()
        ),

    'uni0E0B':      #SO SO
        packline(""
        , ht_main_2(68, 3,tstemw_1,37, 39,tstemw_2,54, ds41="18+8 19+8 20+8 24+8 25+8 31+8 ")
        , h_serif(1)
        , h_head_khuat(67,3,24, 64,58,18, 39, 9,32, [27,28,29,11,12,13])
        , ip_round(32,39,43)
        , tstemw_1(51)
        , ip_round(0,68,48)
        , ix()
        #y
        , sy()
        , v_khai(0, 0, [43,44,51], (29,27),(11,13))
        , v_head_khuat(29, 28,12, 15,61,55,21)
        , vb_khai(0,(39,3))
, add_ip(29,39,[5])
, add_ip(11,0,[33])
        , iy()
        ),

    'uni0E0C':      #CHO CHOE
        packline(""
        , ht_main_2(77, 37,tstemw_1,25, (52,1),tstemw_2,54)
        , h_head_1(64,58,31)
        , h_notch_ko(76,37, 42,20,41,22)
        , 'SROUND 74'
        , ip_round(37,52,13)
        , 'RTG'
        , alignrp(70)
        , tstemw_1(48)
        , shprp2(4)
        , srp0(13)
        , mdrp0mrg(10,"14-8 15-8 ")
        , headstem_1(73)
        , ix()
        #y
        , sy() 
        , v_ko(0, 54,[20,21,22,25,38,41,42],45,17)
        , vb_ching(0,52,(7,34))
        , v_head_1((67,55),(70,61,4),(13,28,49))
        , f_dstr(13,"9+8 10+8 ")
        , f_dstr(49,"9+8 10+8 ")
        , f_dstr(70,"9+8 10+8 ")
        , f_dstr(4,"9+8 10+8 ")
        , iy()
, d_xp(19,15)
        ),

    'base.uni0E0D.descless':      #YO YING
        packline(""
        , ht_main_2(54, 25,tstemw_1,13, 38,tstemw_2,40)
        , h_head_1(50,44,19)
        , h_notch_ko(53,25, 30,8,29,10)
        , ip_round(25,38,1)
        , 'RTG'
        , tstemw_1(36)
        , ix()
        #y
        , sy() 
        , v_ko(0, 40,[8,9,10,13,26,29,30],33,5)
        , vb_khai(0,38)
        , vb0(22)
        , v_head_1(41,47,16)
        , iy()
, d_xp(7,3)
        ),

    'desc.uni0E0D':      #YO YING
        packline(""
        , srp0(35)
        , mdrp0mrw(19)
        , mdrp0rg(3)
        , mdrpb(31)
        , mdrp0rg(25)
        , mdrpb(9)
        , ix()
        #y
        , sy()
        , mdapr(6)
        , alignrp(18)
        , mdrpb(28)
        , mdrp0rg(22)
        , srp0(6)
        , mdrp0rg(0)
        , mdrpb(15)
        , iy()
        ),

    'uni0E0E':      #DO CHADA
        packline(""
        , ht_main_head(79, 37,63,57, 42,30, (18,1),53)
        , h_notch_ko(78,42, 47,25,46,27)
        , srp0(53)
        , mdrp0rg(8)
        , f_ip([69,14,17,2])
        , mdrpg(75)
        , ix()
        #y  
        , sy() 
        , v_ko(78, 0,[25,26,27,30,43,46,47],50,22)
        , srp0(78)
        , vb0(34)
        , v_head_1(54,60,40)
        , tvheight_lu0_1(1)
        , shprp2(5)
        , mdrpmb(18)
        , mdrpmb(66)
        , mdrp0rg(72)
        , mdrpmb(11)
        , add_ip(5,11,[69,14,17,2])
        , iy()
, d_xp(24,20)
        ),

    'uni0E0F':      #TO PATAK
        packline(""
        , ht_main_head(83, 41,67,61, 46,34, (22,1),57)
        , h_notch_ko(82,46, 51,29,50,31)
        , srp0(57)
        , mdrp0rg(10)
        , f_ip([73,16,19,4,20,21,2,3])
        , mdrpg(79)
        , ix()
        #y  
        , sy() 
        , v_ko(82, 0,[29,30,31,34,47,50,51],54,26)
        , srp0(82)
        , vb0(38)
        , v_head_1(58,64,44)
        , tvheight_lu0_1(1)
        , shprp2(3)
        , shprp2(7)
        , mdrpmb(22)
        , mdrpmb(70)
        , mdrp0rg(76)
        , mdrpmb(13)
        , add_ip(7,13,[73,16,19,4,20,21,2])
        , iy()
, d_xp(28,24)
        ),

    'base.uni0E10.descless':      #THO THAN
        packline(""
        , ht_main_2(75, 29,tstemw_1,52, 22,tstemw_2,58)
        , ip_round(74,22,9)
        , headstem_1(71)
        , hsph0_1(65)
        , mdapr(65)
        , mdrpb(14)
        , srp0(58)
        , mdrpg(17)
        , srp0(22)
        , mdrpg(2)
#
        , srp0(75)
        , mdrpmrw(41)
        , ix()
        , fp_mdrp(17,14,2,[4])
        #y
        , sy()
        , v_ro(74, 0,[],32,49, 55,26)
        , vb_ngo(74,0,18)
        , ip_round(26,74,12)
        , v_head_2(68,62,6)
        , iy()
        ),

    'desc.uni0E10':      #THO THAN
        packline(""
        , srp0(62)
        , mdrp0mrw(36)
        , mdrpb(25)
        , mdrpb(40)
        , mdrp0rg(46)
        , mdrpb(30)
        , srp0(36)
        , mdrp0rg(12)
        , mdrpb(58)
        , add_ip(58,25,[52,18,21,23,24,2,3,4,6])
        , ix()
        #y
        , sy()
        , mdapr(33)
        , mdrpb(43)
        , mdrp0rg(37)
        , mdrpb(26)
        , srp0(33)
        , mdrp0rg(0)
        , alignrp(4)
        , alignrp(9)
        , mdrpb(25)
        , mdrpb(23)
        , mdrpb(49)
        , mdrp0rg(55)
        , mdrpb(15)
        , add_ip(15,9,[52,18,21,24,2,6])
        , iy()
        ),

    'uni0E11':      #THO NANGMONTHO
        packline(""
        , ht_main_2(66, 9,tstemw_1,(43,8), 1,tstemw_2,52)
        , h_head_khuat(65,9,30, 62,56,24, 1,15,38, [33,34,35,17,18,19])
        , add_ip(9,52,[6,7,48])
        , add_ip(9,1,[47])
        , ix()
        #y  
        , sy() 
        , v_khai((0,8), 0, [], (35,33,49),(17,19))
        , v_head_khuat(35, 34,18, 21,59,53,27)
        , srp0(0)
        , tstemt_mid_1(46)
        , srp0(35)
        , srp0(49)
        , tstemtc_2(5)
        , iy()
        ),

    'uni0E12':      #THO PHUTHAO
        packline(""
        , ht_main_2(89, 52,tstemwc_1,22, (64,1),tstemw_2,66)
        , mdrp0rg(46)
        , tstemw_1(44)
        , f_ip([27])
        , ip_round(52,64,13)
        , alignrp(82)
        , tstemw_1(60)
        , shprp2(4)
        , srp0(13)
        , mdrp0mrg(10)
        , headstem_1(85)
        , ip_round(52,13,33,ds_dryhead+"13-8 17-8 20-8 ",direction='-')
        , v_head_1(76,70,39)
        , add_ip(46,13,[28])
        , add_ip(33,39,[30])
        , add_ip(28,30,[29])
        , ix()
        #y
        , sy()
        , v_kwai((0,45), 66,[27],(57,55),(17,19))
        , mdrp0mrg(56)
        , mdapr(56,"14-3 15-3 16-3 ")
        , tstemt_2(18)
        , mdapr(18)
        , ip_round(18,0,36,ds_dryhead)
        , v_head_2(73,67,30)
        , f_dstr(27, "13-4 17-8 18-8 19-8 ")
        #
        , vb_ching(0,64,7)
        , headstem_1(79)
        , mdrp0rg(82,"10-8 11-8 ")
        , alignrp(4)
        , headstem_1(13)
        , shprp2(61)
        , iy()
        , f_dstr(31,"14+4 15+4 16+4 ")
, d_xp(21,15)
        ),

    'uni0E13':      #NO NEN
        packline(""
        , srp0(77)
        , mdrprw(46," ")
        , ht_main_2(46, 25,tstemw_1,13, (40,52),tstemw_2,(42,73),s0=76, ds41="")
        , h_head_1(64,58,19)
        , h_notch_ko(76,25, 30,8,29,9)
        #
        , ip_round(25,40,1,"9-8 10-8 ")
        , tstemw_1(36)
        , shprp2(0)
        #
        , srp0(46)
        , headstem_2(70)
        , ix()
        #y
        , sy()
        , v_ko(0, 42,[8,9,10,13,26,29,30],33,5)
        , vb_ching(0,37,(22,49))
        , v_head_1((55,68),61,16)
        #
        , srp0(49)
        , mdrp0rg(73)
        , alignrp(52)
        , headstem_1(43)
        , shprp2(40)
        , iy()
, d_xp(7,3)
        ),

    'uni0E14':      #DO DEK
        packline(""
        , ht_main_2(58, 38,tstemwc_1,8, 1,tstemw_2,44, r=thai_round-2)
        , mdrp0rg(32)
        , tstemw_1(30)
        , f_ip([13])
        , ip_round(38,44,19,ds_dryhead+"13-8 17-8 23-8 ",direction='-')
        , v_head_1(54,48,25)
        , add_ip(32,1,[14])
        , add_ip(19,25,[16])
        , add_ip(14,16,[15])
        , ix()
        #y
        , sy()
        , v_kwai((0,31), 0,[13,22],41,5)
        , mdapr(0)
        , 'SROUND 70'
        , mdapr(22,ds_dryhead)
        , 'RTG'
        , v_head_2(51,45,16)
        , f_dstr(13, "13-4 17-8 18-8 19-8 ")
        , iy()
        , f_dstr(17, "14+4 15+4 16+4 ")
, d_xp(7,3)
        ),

    'uni0E15':      #TO TAO
        packline(""
        , ht_main_2(62, 40,tstemwc_1,10, 1,tstemw_2,48, r=thai_round-2)
        , mdrp0rg(34)
        , tstemw_1(32)
        , f_ip([15])
        , ip_round(40,48,21,ds_dryhead+"13-8 17-8 23-8 ",direction='-')
        , v_head_1(58,52,27)
        , add_ip(34,1,[16])
        , add_ip(21,27,[18])
        , add_ip(16,18,[17])
        , ix()
        #y
        , sy()
        , v_kwai((0,33), 0,[15],(45,43),(5,7))
        , mdapr(0)
        , mdrp0mrg(44)
        , mdapr(44,"14-3 15-3 16-3 ")
        , tstemt_2(6)
        , mdapr(6)
        , 'SROUND 70'
        , ip_round(6,0,24,ds_dryhead)
        , 'RTG'
        , v_head_2(55,49,18)
        , f_dstr(15, "13-4 17-8 18-8 19-8 ")
        , iy()
        , f_dstr(19, "14+4 15+4 16+4 ")
, d_xp(9,3)
        ),

    'uni0E16':      #THO THUNG
        packline(""
        , ht_main_2(50, 25,tstemw_1,13, 1,tstemw_2,36)
        , h_head_1(46,40,19)
        , h_notch_ko(49,25, 30,8,29,9)
        , ix()
        #y
        , sy()
        , v_ko(0, 0,[8,9,10,13,26,29,30],33,5)
        , mdapr(0)
        , vb0(22)
        , v_head_1(37,43,16)
        , iy()
, d_xp(7,3)
        ),

    'uni0E17':      #THO THAHAN
        packline(""
        , ht_main_head(44, 15,40,34, 9,(21,8), 1,30)
        , add_ip(9,30,[6,7,26])
        , add_ip(9,1,[25])
        , ix()
        #y  
        , sy() 
        , v_ko((0,8), 0,[],(27,18),5)
        , v_head_2(37,31,12)
        , srp0(0)
        , tstemt_1(24)
        , iy()
        ),

    'uni0E18':      #THO THONG
        packline(""
        , ht_main_2(44, 3,tstemw_1,41, 37,tstemw_2,36,r=thai_round-1,ds41="10-8 ")
        , h_serif(1)
        , ip_round(43,3,7)
        , tstemw_1(30)
        , srp0(44)
        , mdrpmrw(19)
        , ix()
        #y
        , sy()
        , v_ro(0, 0,[],10,27, 33,(41,4))
        , srp0(0)
        , tstemt_1(37)
        , shprp2(3)
        , iy()
        ),

    'uni0E19':      #NO NU
        packline(""
        , ht_main_head(59, 7,43,37, 1,(0,13), 17,19, ds4x="14-8 16-8 ")
        , srp0(19)
        , mdrp0rg(23)
        , v_head_2(49,55,29)
        , f_dstr(23,"9+4 10+4 11+4 12+4 13+4 ")
        , ix()
        #y
        , sy()
        , v_ngo(0, 19, [], 10)
        , v_head_2(40,34,4)
        , vb_ching(0,14,26)
        , v_head_1(46,52,17)
        , add_ip(17,26,[20,31])
        , f_dstr(17,"9+4 10+4 11+4 12+8 13+8 ")
        , f_dstr(31,"9+4 10+4 11+4 12+8 13+8 ")
        , f_dstr(20,"9+4 10+4 11+4 12+8 13+8 ")
        , iy()
        ),

    'uni0E1A':      #BO BAIMAI
        packline(""
        , ht_main_head(33, 9,29,23, 3,15, 17,19)
        , h_serif(1)
        , ix()
        #y
        , sy()
        , v_ngo(0, 19,[],12)
        , v_head_2(26,20,6)
        , vb_khai(0,(17,3))
        , iy()
        ),

    'uni0E1B':      #PO PLA
        packline(""
        , ht_main_head(33, 9,29,23, 3,15, 17,19)
        , h_serif(1)
        , ix()
        #y
        , sy() 
        , v_ngo(0, 0,[],12)
        , v_head_2(26,20,6)
        , tvheight_po0_1(19)
        , vb_khai(0,(17,3))
        , iy()
        ),

    'uni0E1C':      #PHO PHUNG
        packline(""
        , ht_main_2(60, 14,tstemw_1,[26,13], [44,1],tstemw_2,46)
        , h_head_1(56,50,21)
        , add_ip(14,46,[7,35,36,31,40]) 
        , add_ip(14,44,[5]) 
        , add_ip(26,46,[9]) 
        , ix()
        #y  
        , sy()
        , v_ngo((0,13), 46,[36],18)
        , v_head_2(53,47,24)
        , srp0(0)
        , tstemt_1(42)
        , shprp2(29)
        , mdapr(36)
        , mdrpg(7)
        , iy()
        ),

    'uni0E1D':      #FO FA
        packline(""
        , ht_main_2(60, 14,tstemw_1,[26,13], [44,1],tstemw_2,46)
        , h_head_1(56,50,21)
        , add_ip(26,44,[2,31,35,36,40])
        , add_ip(14,46,[7,35,36,31,40]) 
        , add_ip(14,44,[5]) 
        , add_ip(26,46,[9]) 
        , ix()
        #y  
        , sy()
        , v_ngo((0,13), 0,[],18)
        , v_head_2(53,47,24)
        , srp0(0)
        , tstemt_1(42)
        , shprp2(29)
        , tvheight_po0_1(46)
        , mdapr(36)
        , mdrpg(7)
        , iy()
        ),

    'uni0E1E':      #PHO PHAN
        packline(""
        , ht_main_head(60, 20,56,50, 14,(26,13), (44,1),46)
        , add_ip(14,46,[7,35,36,31,40]) 
        , add_ip(14,44,[5]) 
        , add_ip(26,46,[9]) 
        , ix()
        #y  
        , sy() 
        , v_ngo((0,13), (46,36),[],23)
        , v_head_2(53,47,17)
        , srp0(0)
        , tstemt_1(42)
        , shprp2(29)
        , srp0(36)
        , mdrpg(7)
        , f_dstr(36,"11-4 ")
        , iy()
        ),

    'uni0E1F':      #FO FAN
        packline(""
        , ht_main_head(60, 20,56,50, 14,(26,13), (44,1),46)
        , add_ip(26,44,[2,31,35,36,40])
        , add_ip(14,46,[7,35,36,31,40]) 
        , add_ip(14,44,[5]) 
        , add_ip(26,46,[9]) 
        , ix()
        #y  
        , sy()
        , v_ngo((0,13), 36,[],23)
        , v_head_2(53,47,17)
        , mdapr(0)
        , tstemt_1(42)
        , shprp2(29)
        , tvheight_po0_1(46)
        , srp0(36)
        , mdrpg(7)
        , f_dstr(36,"12-4 13-4 ")
        , iy()
        ),  

    'uni0E20':      #PHO SAMPHAO
        packline(""
        , ht_main_head(50, 20,46,40, 25,13, 1,36)
        , h_notch_ko(49,25, 30,8,29,10)
        , ix()
        #y  
        , sy()
        , v_ko(0, 0,[30,29,26,8,9,10,13],33,5)
        , srp0(0)
        , vb0(17)
        , v_head_1(37,43,23)
        , iy()
, d_xp(7,3)
        ),

    'uni0E21':      #MO MA
        packline(""
        , ht_main_head(54, 19,41,35, 13,(25,4), (29,1),31)
        , srp0(19)
        , mdrp0rg(10)
        , headstem_1(50)
        , hsph0_1(46)
        , mdrpg(6)
        , ix()
        #y  
        , sy()
        , v_ngo(0, 31,[],22)
        , v_head_2(38,32,16)
        , vb_ching(0,29,7)
        , headstem_1(44)
        , mdrp0rg(48)
        , f_ip([4])
        , headstem_1(13)
        , shprp2(26)
        , iy()
        ),

    'uni0E22':      #YO YAK
        packline(""
        , ht_main_2(48, (1,8),tstemw_1,(30,20), 32,tstemw_2,34)
        , mdrpmrg(26)
        , f_ip([5])
        , h_head_1(44,38,15)
        , ix()
        #y  
        , sy() 
        , v_ngo(0, 34,[],12)
        , v_head_2(41,35,18)
        , vb_khai(0,32)
        , ip_round(18,32,25)
        , mdrpmb(26)
        , f_ip([5])
        , iy()
        ),

    'uni0E23':      #RO RUA
        packline(""
        #, ht_main_2(61, 15,tstemw_1,38, 8,tstemw_2,44)
, ht_main_01(61, 15, 8,tstemw_2,44)
, tstemw_1(38)
        , srp0(44)
        , h_head_1r(3,57,51) 
        , srp0(61)
        , mdrpmrw(27)
        , ix()
        #y
        , sy()
        , v_ro(60, 0, [], 18,35, 41,12)
        , srp0(60)
        , vb0(0)
        , v_head_1(48,54,6)
        , iy()
        ),

    'uni0E24':      #RU
        packline(""
        , ht_main_2(50, 25,tstemw_1,13, 1,tstemw_2,36)
        , h_head_1(46,40,19)
        , h_notch_ko(49,25, 30,8,29,9)
        , ix()
        #y
        , sy() 
        , v_ko(49, 0,[8,9,10,13,26,29,30],33,5)
        , mirprg('tvheight_lu',1)
        , srp0(49)
        , vb0(22)
        , v_head_1(37,43,16)
        , iy()
, d_xp(7,3)
        ),

    'uni0E25':      #LO LING
        packline(""
        , ht_main_2(57, 20,tstemw_1,8, (29,1),tstemw_2,43,ds41="11-8 ")
        , mdrprg(36)
        , h_head_1(53,47,14)
        , add_ip(20,29,[4])
        , add_ip(8,43,[25,26])
        , ix()
        , f_dstr(4,"14-2 15-2 16-4 ")
        , f_dstr(3,"14-2 15-2 16-4 ")
        #y
        , sy()
        , v_ko(0, 0,[2,24,27,29],40,33)
        , srp0(0)
        , vb0(17)
        , v_head_1(44,50,11)
#        , mdapr(24)
, ip_round(33,0,24,"16-8 ")
        , tstemtc_thin_2(5)
        , iy()
        , vtlde(37)
, d_x1(31)
        ),

    'uni0E26':      #LU
        packline(""
        , ht_main_head(50, 20,46,40, 25,13, 1,36)
        , h_notch_ko(49,25, 30,8,29,10)
        , ix()
        #y  
        , sy() 
        , v_ko(49, 0,[],33,5)
        , tvheight_lu0_1(1)
        , srp0(49)
        , vb0(17)
        , v_head_1(37,43,23)
        , iy()
, d_xp(7,3)
        ),

    'uni0E27':      #WO WAEN
        packline(""
        , ht_main_01(39, 15, 8,tstemw_2,22)
        , srp0(22)
        , h_head_1r(3,35,29)
        , ix()
        #y
        , sy() 
        , v_ko(38, 0,[],19,12)
        , srp0(38)
        , vb0(0)
        , v_head_1(26,32,6)
        , iy()
        , vtlde(16)
, d_x1(10)
        ),  

    'uni0E28':      #SO SALA
        packline(""
        , ht_main_2(63, 33,tstemwc_1,8, 1,tstemw_2,49, r=thai_round-2)
        , mdrp0rg(27)
        , tstemw_1(25)
        , f_ip([11])
        , srp0(33)
        , mdrp0rg(17,ds_dryhead+"14+8 19+8 ")
        , headstem_2(53)
        , hsph0_2(59)
        , mdrpg(12)
        , add_ip(12,17,[22])
        , ip_round(49,63,43)
        , ix()
        #y
        , sy()
        , v_kwai((0,26), 0,[14,36],36,5)
        , f_ip([39,46])
        , 'SROUND 70'
        , mdapr(14,ds_dryhead)
        , 'RTG'
        , v_head_2(56,50,20)
        , iy()
        , 'SHPIX -8 39'
, d_xp(7,3)
        ),

    'uni0E29':      #SO RUSI
        packline(""
        , ht_main_head(74, 9,58,52, 3,15, (17,38),(48,40),ds41="11-8 ")
        , h_serif(1)
        , srp0(17)
        , mdrp0mrw(30)
        , mdrpb(64)
        , mdrp0rg(70)
        , mdrpb(24)
        , ip_round(48,74,45)
        , ix()
        #y
        , sy() 
        , v_ngo(0, 40,[21],12)
        , v_head_2(55,49,6)
        , vb_khai(0,(17,3))
        #
        , mdapr(21)
        , mdrpmb(35)
        , 'SROUND 70'
        , mdrp0rg(27)
        , 'RTG'
        , mdrpb(67)
        , mdrp0rg(61,"14+8 15+8 ")
        , add_ip(27,21,[18,38,41,48])
        , iy()
        ),

    'uni0E2A':      #SO SUA
        packline(""
        , ht_main_2(67, 20,tstemw_1,8, (29,1),tstemw_2,53,ds41="11-8 ")
        , mdrprg(36)
        , h_head_1(63,57,14)
        , ip_round(53,67,47)
        , add_ip(20,29,[4])
        , add_ip(8,53,[25,26])
        , ix()
        , f_dstr(4,"14-2 15-2 16-4 ")
        , f_dstr(3,"14-2 15-2 16-4 ")
        #y
        , sy() 
        , v_ko(0, 0,[2,24,27,29],40,33)
        , f_ip([43,50])
        , srp0(0)
        , vb0(17)
        , v_head_1(54,60,11)
#        , mdapr(24)
, ip_round(33,0,24,"16-8 ")
        , tstemtc_thin_2(5)
        , iy()
        , vtlde(37)
        , 'SHPIX -8 43'
, d_x1(31)
        ),

    'uni0E2B':      #HO HIP
        packline(""
        , ht_main_head(68, 15,52,46, 9,(21,8), 1,42)
        , srp0(42)
        , mdrp0rg(36)
        , v_head_2(58,64,30)
        , f_dstr(30,"9-4 10-4 11-4 12-4 13-4 17-8 22-8 23-8 ")
        , f_dstr(64,"17-8 22-8 23-8 ")
        , add_ip(9,42,[6,7,26])
        , add_ip(9,1,[25])
        , ix()
        #y  
        , sy() 
        , v_ngo((0,8),0,[],(33,18))
        , v_head_2((61,49),(55,43),12)
        , mdrpmb(5)
        , f_ip([27,38])
        , srp0(0)
        , tstemt_1(24)
        , iy()
        ),

    'uni0E2C':      #LO CHULA
        packline(""
        , ht_main_head(89, 20,73,67, 14,(26,12), (44,1),(63,56))
        , add_ip(14,63,[7,35,36,31,40]) 
        , add_ip(14,44,[5]) 
        , add_ip(26,63,[9]) 
        , srp0(63)
        , h_head_1r(50,85,79)
        , ip_round(63,89,60)
        , ix()
        #y  
        , sy() 
        , v_ngo((0,13), 36,[],23)
        , v_head_2(70,64,17)
        , srp0(1)
        , tstemt_1(42)
        , shprp2(29)
        , srp0(36)
        , mdrpg(7)
        , f_dstr(36,"12-4 13-4 ")
        #
        , mdapr(53)
        , v_head_2(82,76,47)
        , add_ip(53,47,[56,63])
        , iy()
        ),

    'uni0E2D':      #O ANG
        packline(""
        , ht_main_2(43, 1,tstemw_1,13, 15,tstemw_2,29)
        , mdrprg(22)
        , h_head_1(39,33,8)
        , ix()
        #y
        , sy() 
        , v_ko(0, 0,[5],26,19)
        , vb_khai(0,15)
        , mdapr(5,ds_dryhead)
        , v_head_2(36,30,11)
        , iy()
        , vtlde(23)
, d_x1(17)
        ),  

    'uni0E2E':      #HO NOKHUK
        packline(""
        , ht_main_2(67, 1,tstemw_1,13, 15,tstemw_2,41)
        , h_head_1(51,45,8)
        , srp0(1)
        , mdrp0rg(25)
        , mdrpmg(63)
        , add_ip(25,41,[57,31,38,19])
        , ip_round(41,68,35)
        , f_dstr(57,ds_tstemwc,direction='-')
        , f_dstr(38,ds_tstemwc)
        , ix()
, 'SHPIX 16 57'
, 'SHPIX -16 38'
        #y
        , sy()
        , v_ngo(0, 0,[22],28)
        , mdrpb(60)
        , mdrp0rg(54)
        , mdapr(54)
        , mdrpb(22)
        , vb_khai(0,15)
        , ip_round(22,0,5,ds_dryhead)
        , v_head_2(48,42,11)
        , add_ip(28,22,[57,31,38,19])
        , iy()
, 'SHPIX -8 31'
, 'SHPIX 8 19'
, f_dstr(18,"15+3 16+4 ")
, d_x1(17)
        ),

    'uni0E2F':      #PAIYANNOI
        packline(""
        , ht_main_01(41, 12, (3,26),tstemw_2,27)
        , v_head_1(37,31,18)
        , srp0(3)
        , h_serif(1)
        , ix()
        #y
        , sy()
        , v_ngo(0, 27,[6],15)
        , tstemt_2(6)
        , headstem_2(34)
        , hsph0_2(28)
        , mdapr(28)
        , mdrp0rg(23)
        , tstemt_2(9)
        , vb_khai(0,3)
        , iy()
        ),

    'uni0E30':      #SARA A
        packline(""
        , srp0(67)
        , mdrp0mrw(18)
        , alignrp(51)
        , mdrp0rg(3,"10+8 ")
        , alignrp(36)
        , v_head_1((30,63),(24,57),(9,42))
        , f_ip([12,14,47])
        , f_dstr(12,ds_tstemw)
        , srp0(12)
        , alignrp(45)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpmb(14,"16-1 ")
        , mdrp0rg(6,"11-8 12-8 16-8 20-8 21-8 ")
        , headstem_2(27)
        , hsph_2(21)
        #
        , mdapr(39)
        , headstem_2(60)
        , hsph_2(54)
        , mdrp0rg(33,"11-8 12-8 16-8 20-8 21-8 ",direction="-")
        , mdrpmb(47,"16-1 ")
        , iy()
        ),

    'uni0E31':      #MAI HAN-AKAT
        packline(""
        , mdapr(33)
        , mdrp0mrw(9)
        , mdrprg(18)
        , v_head_2(24,30,3)
        , ix()
        #y
        , sy()
        , v_sara(0)
        , mdrpb(14)
        , 'SROUND 69'
        , mdrp0rg(6)
        , 'RTG'
        , headstem_2(27)
        , hsph_2(21)
        , iy()
        ),

    'uni0E32':      #SARA AA
        packline(""
        , ht_main_01(17, 8, 1,tstemw_2,15)
        , ix()
        #y
        , sy()
        , v_ko(0, 0,[],12,5)
        , iy()
        , vtlde(9)
, d_x1(3)
        ),

    'uni0E34':      #SARA I
        packline(""
        , mdapr(14)
        , mdrp0mrw(0)
        , mdrpb(7)
        , mdrp0rg(13)
        , mdrpb(1)
        , ix()
        #y
        , sy()
        , mdapr(14)
        , v_sara(0)
        , mdrpb(7,"15-1 16-1 ")
        , mdrp0mrg(10)
        , mdrpb(4)
        , iy()
        , dryend(2)
        , dryend(6)
        ),

    'uni0E35':      #SARA II
        packline(""
        , mdapr(17)
        , mdrp0mrw(0)
        , mdrpb(7)
        , mdrpb(10)
        , mdrp0rg(16)
        , mdrpb(1)
        , ix()
        #y
        , sy()
        , mdapr(17)
        , v_sara(0)
        , mdrpb(10,"15-1 16-1 ")
        , mdrp0mrg(13)
        , mdrp0b(4)
        , mdrpmrg(9)
        , 'SROUND 73'
        , mdapr(9)
        , 'RTG'
        , iy()
        , dryend(2)
        , dryend(6)
        ),

    'uni0E36':      #SARA I
        packline(""
        , mdapr(36)
        , mdrp0mrw(0)
        , mdrpb(17)
        , mdrp0rg(23)
        , mdrpb(1)
        , srp0(0)
        , mdrp0mrg(12)
        , mdrpb(27)
        , mdrp0rg(33)
        , mdrpb(6)
        , ix()
        #y  
        , sy() 
        , mdapr(36)
        , v_sara(0)
        , mdrpb(17,"15-1 16-1 ")
        , mdrp0mrg(20)
        , mdrp0b(4)
        , mdrp0mrg(9)
        , mdapr(9)
        , mdrpb(30)
        , mdrp0mrg(24)
        , mdrpb(15)
        , iy()
        , dryend(2)
        , dryend(6)
        ),  

    'uni0E37':      #SARA UEE
        packline(""
        , mdapr(21)
        , mdrp0mrw(0)
        , mdrpb(14,"15-1 16-1 ")
        , mdrp0b(12)
        , mdrp0mrg(9)
        , mdapr(9)
        , mdrpb(7)
        , srp0(0)
        , mdrp0rg(20)
        , mdrpb(1)
        , ix()
        #y  
        , sy()
        , mdapr(21)
        , v_sara(0)
        , mdrpb(14)
        , mdrp0mrg(17)
        , mdrp0b(4)
        , mdrpmrg(7)
        , 'SROUND 73'
        , mdapr(7)
        , 'RTG'
        , alignrp(12)
        , add_ip(4,14,[9,11])
        , iy()
        , dryend(2)
        , dryend(10)
        ),

    'uni0E38':      #SARA U
        packline(""
        , srp0(25)
        , mdrp0mrw(12)
        , mdrpmb(1)
        , mdrp0rg(22)
        , mdrpmb(6)
        , mdrpw(16)
        , ix()
        #y
        , sy()
        , mdapr(25)
        , mdrp0rw(9)
        , mdrpmb(19)
        , 'SROUND 71'
        , mdrp0rg(13)
        , 'RTG'
        , mdrp0mb(3)
        , mdrpmrg(1)
        , 'SROUND 73'
        , mdapr(1)
        , 'RTG'
        , iy()
        ),

    'uni0E39':      #SARA UU
        packline(""
        , srp0(33)
        , mdrp0mrw(18)
        , mdrpb(16)
        , mdrp0rg(12)
        , mdrpb(1)
        , mdrp0rg(30)
        , mdrpw(24)
        , mdrpmb(6)
        , ix()
        #y
        , sy()
        , mdapr(33)
        , mdrp0rw(17)
        , mdrp0g(9)
        , mdrpb(27)
        , srp0(17)
        , mdrp0mrg(21)
        , mdrp0b(3)
        , mdrpmrg(1)
        , 'SROUND 73'
        , mdapr(1)
        , 'RTG'
        , mdrpb(13)
        , iy()
        ),

    'uni0E3A':      #PHINTHU
        packline(""
        , srp0(12)
        , mdrp0mrw(9)
        , mdrpmrb(3)
        , ix()
        #y  
        , sy()
        , mdapr(12)
        , mdrp0mrw(6)
        , mdrpmrb(0)
        , iy()
        ),

    'uni0E3F':      #THAI BAHT
        packline(""
        , ht_main_2(50, 3,tstemw_num_1,(34,47), 27,tstemw_num_2,18)
        , srp0(18)
        , mdrp0rg(12)
        , tstemw_num_2(40)
        , ip_round(34,40,32)
        , alignrp(2)
        , alignrp(45)
        , alignrp(5)
        , mdrpb(31)
        , shprp2(22)
        , shprp2(44)
        , shprp2(7)
        , ix()
        #y  
        , sy()
        , mdapr(22)
        , alignrp(2)
        , mdrprg(0)
        , mdrpmb(23,ds_tstemt)
        , shprp2(32)
        , mdrp0rg(8)
        , alignrp(5)
        , mdrprg(7)
        , mdrpmb(44,ds_tstemt,direction='-')
        , shprp2(46)
        , ip_round(44,23,36)
        , alignrp(45)
        , mdrpmb(31,ds_tstemt,direction='-')
        , shprp2(33)
        , f_ip([15])
        , iy()
        ),

    'uni0E40':      #SARA AA
        packline(""
        , srp0(26)
        , 'SROUND 70'
        , mdrp0rg(3)
        , 'RTG'
        , tstemw_1(5)
        , h_head_1(23,17,11)
        , ix()
        #y
        , sy()
        , evheight0_1(5)
        , mdapr(26)
        , vb0(0)
        , v_head_1(14,20,8)
        , iy()
        ),

    'uni0E42':      #SARA O
        packline(""
        , ht_main_10(61, 3,tstemw_1,39, 45, min3=False)
        , h_head_1(57,51,45)
        , ip_round(60,3,10)
        , tstemw_1(33)
        , mdrprg(22)
        , ix()
        #y
        , sy() 
        , mdapr(13)
        , tstemt_num_2(30)
        , mdrp0rg(36)
        , mdapr(36)
        , tstemt_thin_2(7)
        , mdapr(60)
        , vb0(0)
        , v_head_1(48,54,42)
        , iy()
        ),

    'uni0E43':      #SARA AI MAIMUAN
        packline(""
        , ht_main_10(68, 3,tstemw_1,34, 40, min3=False)
        , h_head_1(52,46,40)
        , ip_round(67,3,23)
        , v_head_1(64,58,17)
        , ip_round(17,68,9)
        , tstemw_1(29)
        , ix()
        #y
        , sy() 
        , mdapr(26)
        , tstemt_thin_2(12)
        , mdrp0rg(20)
        , headstem_1(55)
        , hsph_1(61)
        #
        , mdapr(67)
        , vb0(0)
        , v_head_1(43,49,37)
        , iy()
        ),

    'uni0E44':      #SARA AI MAIMALAI
        packline(""
        , ht_main_10(55, 3,tstemw_1,33, 39, min3=False)
        , h_head_1(51,45,39)
        , srp0(3)
        , mdrp0mrw(9)
        , mdrpb(27)
        , mdrp0mrg(23)
        , mdrpb(15)
        , mdrp0mrg(19)
        , ix()
        , f_dstr(24, "13-4 14-4 15-4 16-4 ")
        , f_dstr(8, "13-4 14-4 15-4 16-4 ")
        #y
        , sy() 
        , mdapr(30)
        , mdrp0rg(19)
        , mdrpb(18)
        , srp0(30)
        , tstemtc_2(7)
        , mdrp0rg(12)
        , tstemtc_1(25)
        #
        , mdapr(54)
        , vb0(0)
        , v_head_1(42,48,36)
        #
        , iy()
        ),

    'uni0E45':      #LAKKHANGYAO
        packline(""
        , srp0(16)
        , mdrp0rw(8)
        , mdrp0rg(15)
        , tstemw0_2(1)
        , ix()
        #y
        , sy()
        , v_ko(16, 0,[],12,5)
        , tvheight_lu0_1(1)
        , iy()
        , vtlde(9)
, d_x1(3)
        ),

    'uni0E46':      #MAIYAMOK
        packline(""
        , ht_main_01(40, 18, 1,tstemw_2,26)
        , mdrp0rg(30)
        , headhole_2(36)
        , headstem_1(12)
        , add_ip(18,26,[21,22,23,5,6,7])
        , ix()
        #y
        , sy()
        , v_ko(39, 0,[],(23,21),(5,7))
        , mdrp0mrg(22)
        , tstemt_2(6)
        , mdrp0rg(9)
        , v_head_2(33,27,15)
        , tvheight_lu0_1(1)
        , iy()
        ),

    'uni0E47':      #MAITAIKHU
        packline(""
        , srp0(64)
        , mdrp0mrw(49)
        , mdrpmrg(22)
        , mdrpb(55)
        , mdrp0rg(61)
        , mdrpb(43)
        , mdrp0rg(32)
        , f_ip([38,5])
        , mdrpb(11)
        , ix()
        #y
        , sy()
        , mdapr(64)
        , v_sara(0)
        , alignrp(8)
        , mdrpb(52)
        , mdrpb(43)
        , mdrpb(35)
        , mdrp0rg(58)
        , mdrpb(46)
        , srp0(0)
        , mdrp0rg(38,"")
        , mdrpb(5)
        , srp0(0)
        , mdrp0rg(29,"13+8 14+8 ")
        , mdrpb(14)
        , iy()
        ),

    'base.uni0E47.high':      #MAITAIKHU
        packline(""
        , mdapr(49)
        , mdrpmrg(22)
        , mdrpb(55)
        , mdrp0rg(61)
        , mdrpb(43)
        , mdrp0rg(32)
        , f_ip([38,5])
        , mdrpb(11)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(8)
        , mdrpb(52)
        , mdrpb(43)
        , mdrpb(35)
        , mdrp0rg(58)
        , mdrpb(46)
        , srp0(0)
        , mdrp0rg(38)
        , mdrpb(5)
        , srp0(0)
        , mdrp0rg(29)
        , mdrpb(14)
        , iy()
        ),

    'uni0E48':      #MAI EK
        packline(""
        , srp0(4)
        , mdrp0mrw(0)
        , mdrpmb(1)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpmb(3)
        , iy()
        ),

    'base.uni0E48.low':      #MAI EK
        packline(""
        , srp0(4)
        , mdrp0mrw(0)
        , mdrpmb(1)
        , ix()
        #y
        , sy()
        , mdapr(4)
        , v_sara(0)
        , mdrpmb(3)
        , iy()
        ),

    'uni0E49':      #MAI THO
        packline(""
        , mdapr(17)
        , mdrpb(16)
        , mdrp0rg(10)
        , mdrpb(23)
        , mdrp0rg(29)
        , mdrpb(4)
        , mdrp0rg(0)
        , mdrpb(13)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpb(13)
        , mdrp0rg(1)
        , mdrpb(20)
        , mdrp0rg(26)
        , mdrpb(7)
        , mdrpmrg(17)
        , iy()
        ),

    'base.uni0E49.low':      #MAI THO
        packline(""
        , mdapr(17)
        , mdrpb(16)
        , mdrp0rg(10)
        , mdrpb(23)
        , mdrp0rg(29)
        , mdrpb(4)
        , mdrp0rg(0)
        , mdrpb(13)
        , ix()
        #y
        , sy()
        , mdapr(32)
        , v_sara(0)
        , mdrpb(13)
        , mdrp0rg(1)
        , mdrpb(20)
        , mdrp0rg(26)
        , mdrpb(7)
        , mdrpmrg(17)
        , iy()
        ),

    'uni0E4A':      #MAI TRI
        packline(""
        , mdapr(27)
        , mdrpb(3)
        , mdrp0rg(33)
        , mdrpb(32)
        , srp0(27)
        , mdrp0rg(19)
        , mdrpb(10)
        , mdrpb(45)
        , mdrp0rg(39)
        , mdrpb(13)
        , add_ip(19,27,[22,23,24,6,7,8])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(16)
        , mdrpb(29)
        , mdrpb(36)
        , mdrp0rg(42)
        , mdrpb(10)
        , mdrp0rg(8)
        , alignrp(6)
        , mdrpb(22)
        , shprp2(24)
        , mdrpmb(32)
        , iy()
        ),

    'base.uni0E4A.low':      #MAI TRI
        packline(""
        , srp0(48)
        , mdrp0mrg(27)
        , mdrpb(3)
        , mdrp0rg(33)
        , mdrpb(32)
        , srp0(27)
        , mdrp0rg(19)
        , mdrpb(10)
        , mdrpb(45)
        , mdrp0rg(39)
        , mdrpb(13)
        , add_ip(19,27,[22,23,24,6,7,8])
        , ix()
        #y
        , sy()
        , mdapr(48)
        , v_sara(0)
        , alignrp(16)
        , mdrpb(29)
        , mdrpb(36)
        , mdrp0rg(42)
        , mdrpb(10)
        , mdrp0rg(8)
        , alignrp(6)
        , mdrpb(22)
        , shprp2(24)
        , mdrpmb(32)
        , iy()
        ),

    'uni0E4B':      #MAI CHATTAWA
        packline(""
        , mdapr(0)
        , alignrp(16)
        , mdrpmrg(22)
        , mdrp0b(2)
        , alignrp(14)
        , mdrpmrb(7)
        , ix()
        #y  
        , sy()
        , mdapr(0)
        , mdrp0mrg(23)
        , alignrp(6)
        , mdrp0b(20)
        , alignrp(9)
        , mdrpmrb(15)
        , iy()
        ),

    'base.uni0E4B.low':      #MAI CHATTAWA
        packline(""
        , srp0(28)
        , mdrp0mrw(0)
        , alignrp(16)
        , mdrprg(22)
        , mdrp0b(2)
        , alignrp(14)
        , mdrpmrg(7)
        , ix()
        #y  
        , sy() 
        , mdapr(28)
        , v_sara(0)
        , mdrp0mrg(23)
        , alignrp(6)
        , mdrp0b(20)
        , alignrp(9)
        , mdrpmb(15)
        , iy()
        ),

    'uni0E4C':      #THANTHAKHAT
        packline(""
        , mdapr(10)
        , mdrp0rg(3)
        , mdrpb(29)
        , mdrp0rg(23)
        , mdrpb(17)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpb(20)
        , mdrp0rg(26)
        , mdrp0rg(13)
        , mdrpb(6)
        , iy()
        ),

    'base.uni0E4C.low':      #THANTHAKHAT
        packline(""
        , srp0(32)
        , mdrp0rg(3)
        , mdrprg(10)
        , mdrpb(29)
        , mdrp0rg(23)
        , mdrpb(17)
        , ix()
        #y
        , sy()
        , mdapr(32)
        , v_sara(0)
        , mdrpb(20)
        , mdrp0rg(26)
        , mdrp0rg(13)
        , mdrpb(6)
        , iy()
        ),

    'uni0E4D':      #NIKHAHIT
        packline(""
        , mdapr(9)
        , mdrpb(15)
        , mdrp0rg(21)
        , mdrpb(3)
        , ix()
        #y
        , sy() 
        , mdapr(24)
        , v_sara(0)
        , mdrpb(12)
        , mdrp0rg(18)
        , mdrpb(6)
        , iy()
        ),  

    'base.uni0E4D.high':      #NIKHAHIT
        packline(""
        , mdapr(9)
        , mdrpb(15)
        , mdrp0rg(21)
        , mdrpb(3)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpb(12)
        , mdrp0rg(18)
        , mdrpb(6)
        , iy()
        ),

    'uni0E4E':      #YAMAKKAN
        packline(""
        , srp0(38)
        , mdrp0mrw(37)
        , mdrp0rg(15)
        , mdrprg(25)
        , f_ip([35])
        , mdrp0rg(20)
        , mdrpb(9)
        , mdrp0rg(29)
        , mdrpb(3)
        , ix()
        #y
        , sy()
        , mdapr(38)
        , tvheight0_1(37)
        , mdrp0mrw(0)
        , mdrpb(32)
        , mdrp0rg(25)
        , mdrpb(24)
        , f_ip([6])
        , mdrp0rg(17)
        , mdrpb(12)
        , iy()
        ),

    'uni0E4F':      #FONGMAN
        packline(""
        , ht_main_2(37, 3,tstemw_num_1,21, 15,tstemw_num_2,9)
        , add_ip(21,15,[27,33])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , tstemw_num_1(12)
        , mdapr(6)
        , tstemw_num_2(18)
        , add_ip(18,12,[30,24])
        , iy()
        ),  

    'uni0E50':      #THAI DIGIT ZERO
        packline(""
        , ht_main_2(25, 3,tstemwc_num_1,21, 15,tstemwc_num_2,9)
        , ix()
        #y
        , sy()
        , vt_num(24, 0,[],6,18)
        , srp0(24)
        , vb0(0)
        , tstemtc_num_1(12)
        , iy()
        ),

    'uni0E51':      #THAI DIGIT ONE
        packline(""
        , ht_main_2(52, 3,tstemwc_num_1,22, 16,tstemwc_num_2,9)
        , ip_round(22,16,30)
        , v_head_1(48,42,36)
        , srp0(9)
        , mdrprg(13)
        , ix()
        #y
        , sy()
        , vt_num(51, 0,[],6,19)
        , mdapr(0)
        , alignrp(13)
        , tstemtc_num_1(25)
        , mdrp0rg(33)
        , headstem_2(45)
        , hsph_2(39)
        , iy()
, fp_mirp(13,12,13,'tstemtc_num',[12])
        ),

    'uni0E52':      #THAI DIGIT TWO
        packline(""
        , ht_main_2(54, 1,tstemw_num_1,9, 14,tstemwc_num_2,38)
        , mdrprg(5)
        , srp0(9)
        , mdrp0mrw(30)
        , mdapr(30)
        , v_head_1(50,44,24)
        , add_ip(30,38,[33,34,35,17,18,19])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , tstemt_num_1(11)
        , vt_num(0, 0,[], (35,33),(17,19))
        , mdrprg(6)
        , mdrp0mrg(18)
        , f_ip([34])
        , srp0(11)
        , mdrp0mrw(27)
        , mdapr(27)
        , headstem_1(41)
        , hsph_1(47)
        , iy()
        ),

    'uni0E53':      #THAI DIGIT THREE
        packline(""
        , ht_main_2(60, 32,tstemwc_num_1,19, 4,tstemwc_num_2,44)
        , mdrp0rg(26)
        , hsph_2(56)
        , headstem_2(50)
        , ip_round(32,4,12)
        , tstemw_num_1(10)
        , f_ip([38])
        , ix()
        #y
        , sy()
        , vt_num(0, 0,[],(41,35),(7,16))
        , mdrprg(11)
        , f_ip([38])
        , srp0(0)
        , vb0(29)
        , v_head_1(47,53,23)
        , iy()
        ),

    'uni0E54':      #THAI DIGIT FOUR
        packline(""
        , ht_main_10(61, 10,tstemwc_num_1,25, 47)
        , srp0(61)
        , mdrprw(18)
        , ip_round(10,47,33)
        , v_head_1(57,51,39)
        , add_ip(33,39,[42,30])
        , ix()
        #y
        , sy()
        , mdapr(60)
        , tvheight_num0_1(13)
        , tstemt_num_2(21)
        , srp0(60)
        , vb0((0,7))
        , mdrpg(2)
        , tstemtc_num0_1(47)
        , alignrp(28)
        , mdrpg(45)
        , ip_round(21,28,42,"11-8 14-8 ")
        , v_head_1(48,54,36)
        , iy()
        ),

    'uni0E55':      #THAI DIGIT FIVE
        packline(""
        , ht_main_10(82, 10,tstemwc_num_1,34, 56)
        , srp0(82)
        , mdrprw(27)
        , ip_round(10,56,42)
        , v_head_1(66,60,48)
        , add_ip(42,48,[51,39])
        , ip_round(10,27,15)
        , v_head_1(78,72,21)
        , ix()
        #y
        , sy()
        , mdapr(81)
        , tvheight_num0_1(69)
        , mdrpg(23)
        , mdrpg(13)
        , tstemt_num_2(30)
        , srp0(81)
        , vb0((0,7))
        , mdrpg(2)
        , tstemt_num0_1(56)
        , alignrp(37)
        , mdrpg(54)
        , ip_round(30,37,51,"11-8 14-8 ")
        , v_head_1(57,63,45)
        , srp0(69)
        , hsph0_1(18)
        , headstem_2(75)
        , iy()
        ),

    'uni0E56':      #THAI DIGIT SIX
        packline(""
        , ht_main_2(51, (22,3),ds_estemwc,29, 16,tstemwc_num_2,35)
        , mdrpg(29)
        , mdrprg(25)
        , v_head_1(47,41,9)
        , ix()
        #y
        , sy()
        , vt_num(50, 0,[],32,19)
        , mdrp0mrg(22,"9+8 ")
        , mdapr(22)
        , mdrpb(29,ds_tstemtc_num)
        , mdrp0mrw(6)
        , headstem_2(44)
        , hsph_2(38)
        , add_ip(38,50,[2])
        , srp0(32)
        , mdrp0rg(26)
        , tstemtc_2(25)
        , srp0(50)
        , vb0(0)
        , tstemtc_num_1(13)
        , iy()
        ),

    'uni0E57':      #THAI DIGIT SEVEN
        packline(""
        , ht_main_2(74, 30,tstemwc_num_1,17, 49,tstemw_num_2,57)
        , mdrp0rg(24)
        , hsph_2(70)
        , headstem_2(64)
        , srp0(49)
        , mdrp0mrw(42)
        , mdapr(42)
        , tstemwc_num_2(4)
        , add_ip(30,42,[36])
        , add_ip(30,4,[11])
        , add_ip(17,42,[10])
        , f_ip([36])
        , srp0(57)
        , mdrprg(54)
        , ix()
        #y
        , sy()
        , vt_num(0, 0,[],(39,33),(7,14))
        , mdrp0rg(53)
        , tstemtc_2(54)
        , srp0(0)
        , tstemt_num_1(45)
        , vb0(27)
        , v_head_1(61,67,21)
        , ip_round(7,21,10)
        , add_ip(10,39,[36])
        , iy()
        ),

    'uni0E58':      #THAI DIGIT EIGHT
        packline(""
        , ht_main_2(63, 11,tstemwc_num_1,26, 38,ds_tstemwc_num,47)
        , mdrp0rg(29)
        , tstemw_num_1(8)
        , srp0(47)
        , mdrprg(19)
        , v_head_2(53,59,41)
        , add_ip(29,38,[32,34,35,0,2,3])
        , ix()
        , f_dstr(17,"17-8 18-8 ")
        #y
        , sy()
        , mdapr(62)
        , tvheight_num0_1(15)
        , tstemt_num_2(22)
        , srp0(62)
        , vb0((0,8))
        , tstemtc_num_1(37)
        , shprp2(29)
        , mdrp0rg(44)
        , mdapr(44)
        , v_head_2(56,50,38)
        , srp0(0)
        , 'SROUND 71'
        , mdrp0rg(32)
        , mdapr(32)
        , 'RTG'
        , tstemt_num_2(5)
        , add_ip(32,0,[34,35,2,3])
        , iy()
        ),

    'uni0E59':      #THAI DIGIT NINE
        packline(""
        , ht_main_2(62, 21,tstemwc_num_1,8, 41,tstemwc_num_2,40)
        , mdrp0rg(15)
        , headstem_2(52)
        , hsph_2(58)
        , add_ip(21,58,[19])
        , ip_round(8,40,46)
        , mdrp0mrb(2)
        , alignrp(27)
        , mdrpg(1)
        , tstemwc_num0_1(48)
        , mdrpg(0)
        , srp0(40)
        , mdrprg(37)
        , add_ip(41,40,[32])
        , ix()
        #y
        , sy()
        , vt_num(0, 0,[],(30,24),(44,5))
        , mdrp0rg(36)
        , tstemtc_2(37)
        , srp0(44)
        , mdrp0mrg(41)
        , tstemt_num_1(33)
        , mdapr(0)
        , vb0(18)
        , v_head_1(49,55,12)
        , iy()
        ),

    'uni0E5A':      #ANGKHANKHU
        packline(""
        , srp0(45)
        , mdrp0mrw(43)
        , tstemw0_2(41)
        , mdrp0mrw(0)
        , mdapr(0)
        , tstemw0_2(3)
        , alignrp(26)
        , h_serif(1)
        , ip_round(44,3,12)
        , v_head_1(37,31,18)
        , ix()
        #y
        , sy() 
        , v_ngo((0,40), (27,43),[],15)
        , tstemt_2(6)
        , headstem_2(34)
        , hsph0_2(28)
        , mdapr(28)
        , mdrp0rg(23)
        , tstemt_2(9)
        , vb_khai(0,3)
        , iy()
        ),

    'uni0E5B':      #KHOMUT
        packline(""
        , ht_main_10(79, 3,tstemw_num_1,23, 48)
        , 'RDTG'
        , mdrp0rg(15)
        , 'RTG'
        , v_head_1(75,69,9)
        , mdrp0mrg(29)
        , tstemw_num0_1(30)
        , f_ip([63])
        , mdrp0rg(36)
        , tstemw_num0_1(37)
        , f_ip([57])
        , mdrp0rg(43)
        , tstemw_num0_1(44)
        , f_ip([51])
        , ix()
        #y
        , sy()
        , mdapr(79)
        , mdrpg(0)
        , tvheight_num0_1(6)
        , tstemt_num_2(20)
        , 'RDTG'
        , mdrp0rg(67)
        , 'RTG'
        , headhole_1(73)
        , headstem_2(12)
        , srp0(0)
        , tstemt_num_1(26)
        , ip_round(6,0,29)
        , alignrp(36)
        , alignrp(43)
        , mdrp0mrw(46)
        , tstemt_num_2(49)
        , ip_round(29,0,60)
        , alignrp(54)
        , tstemt_num_1(33)
        , shprp2(40)
        , add_ip(29,60,[63,57,51])
        , iy()
        ),

}

### THESE LINES IN THE BOTTOM
self_func = []
for i in dir():
    if callable(eval(i)): self_func.append(i)

for i in pseudo_code_dict.keys():
    p_list = pseudo_code_dict[i].split('\n')
    for j in range(len(p_list)):
        if '(' in p_list[j]:
            if p_list[j].split('(',1)[0] in self_func:
                l = [n for n in range(len(p_list[j])) if p_list[j][n] == ')']
                t = p_list[j][:l[-1]+1]
                p_list[j] = p_list[j].rep_listace(t, eval(t))
    pseudo_code_dict[i] = '\n'.join(p_list)


